/**
 * The CassidyHouseKey class represents a key looted from Cassidy.
 */
function CassidyHouseKey() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Cassidy's House Key";
    var itemDescription = "The key to Cassidy's luxurious home in the hamlet.";
    var baseValue = 200;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.CASSIDY_HOUSE_KEY;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.MISC;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var lowerCase = itemName.toLowerCase();
        lowerCase = lowerCase.charAt(0).toUpperCase() + lowerCase.substr(1);
        var toReturn = caps ? itemName : lowerCase;
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 200px;";
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {CassidyHouseKey-stripped} key A CassidyHouseKey object, stripped of private members and all functions.
     */
    this.load = function (key) {

    };
}
