/**
 * A single spring.
 */
function LockPickingSpring(id, key, master, position, active) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var uniqueIdentifier = arguments.callee.name;
    var elementId = id + "_" + key + "_" + uniqueIdentifier + position;

    var ctrl = new ChoiceController(id, elementId);

    if (!active) {
        ctrl.set(true);
    }

    var image = new LockPickingPreloadingSpring();
    
    var upHeight = "120px";
    var downHeight = "300px";
    var width = "150px";
    
    var downTime = 750;
    var fastDownTime = 300;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    
    /**
     * Animates the tumbler going up.
     */
    function animateUp(time) {
        $("#" + elementId).animate({height: upHeight}, time, animateDownSlow);
    }
    
    /**
     * Animates the tumbler going down slowly.
     */
    function animateDownSlow() {
        $("#" + elementId).animate({height: downHeight}, downTime);
    }

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML required for the minigame.
     */
    this.build = function () {
        var spring = `<img class="spring spring${position}" src=${image.url} id="${elementId}" style="width: ${width}; height: ${ctrl.get() ? upHeight : downHeight};">`;
        return spring;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {

    };

    /**
     * Causes this spring to go up.
     * @param {int} time How quickly it should go up, in milliseconds
     */
    this.up = function (time) {
        if(ctrl.get()) {
            return;
        }
        animateUp(time);
    };
    
    this.stop = function() {
        ctrl.set(true);
        $("#" + elementId).stop(true, false);
    };
    
    /**
     * Causes this spring to go down.
     */
    this.reset = function() {
        if (!active) {
            return;
        }

        ctrl.set(false);
        $("#" + elementId).stop(true, false);
        $("#" + elementId).animate({height: downHeight}, fastDownTime);
    };
}

