/**
 * A class representing the metadata of a single save.
 * @param {int} id The slot the save was read from.
 * @param {string} currentScene The save's current scene.
 * @param {string} currentSceneName The name of the save's current scene.
 * @param {string} saveComment The save's comment.
 * @param {string} saveName The name of the kobold.
 * @param {GenderEnum} saveGender The gender of the kobold.
 * @param {string} timeStamp The time at which the save was made.
 */
function SaveMetaData(id, currentScene, currentSceneName, saveComment, saveName, saveGender, timeStamp) {
    // PRIVATE MEMBERS \\       var private = "test";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.slot = id;
    this.scene = currentScene;
    this.sceneName = currentSceneName;
    this.comment = saveComment;
    this.name = saveName;
    this.gender = saveGender;
    this.time = timeStamp;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
}
