/**
 * Controller for the Farmer's Maid scene.
 * @param {string} sceneId The id of the scene.
 */
function FarmerMaidController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = false;
    this.nextSceneName = "SlaveAfternoonTwo";
    this.nextFolderName = "Enslavement/DayTwo";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ContinueController(id, "arrival");
    this.gender = new ChoiceController(id, "gender");
    this.claws = new ContinueController(id, "claws");
    this.teeth = new ContinueController(id, "teeth");
    this.recover = new ChoiceController(id, "recover");
    this.preMaid = new ContinueController(id, "preMaid");
    this.maid = new ChoiceController(id, "maid");
    this.postMaid = new ContinueController(id, "postMaid");
    this.preParents = new ContinueController(id, "preParents");
    this.parents = new ChoiceController(id, "parents");
    this.postParents = new ContinueController(id, "postParents");
    this.daily = new ContinueController(id, "daily");

    this.toofar = new ContinueController(id, "toofar");
    this.toofarTell = new ContinueController(id, "toofarTell");
    
    this.girlfriend = new ContinueController(id, "girlfriend");
    this.jealous = new ContinueController(id, "jealous");
    this.frame = new ContinueController(id, "frame");
    
    this.drunk = new ChoiceController(id, "drunk");
    this.postDrunk = new ContinueController(id, "postDrunk");
    this.preDeath = new ContinueController(id, "preDeath");
    this.death = new ChoiceController(id, "death");


    this.parentsChoice = {
        LEAVE: 1,
        WATCH: 2,
        HANDJOB: 3,
        BLOWJOB: 4,
        NOPEN: 5,
        FUCK: 6
    };

    /*this.proposal = new ChangeController(id, "proposal", function () {
     }, function () {
     return global.ui.change.buildNotification([
     new Change("TODO", "CHANGE", +1)
     ]);
     });*/

    this.fragments = {};
    this.fragments.dog = new FarmerMaidDrunkDeclineDog(this);
    this.fragments.satisfied = new FarmerMaidDrunkSatisfy(this);
    this.fragments.amorousDaily = new FarmerMaidAmorousDaily(this);
    this.fragments.absentDaily = new FarmerMaidAbsentDaily(this);
    this.fragments.abusiveDaily = new FarmerMaidAbusiveDaily(this);
    this.fragments.blowjob = new FarmerMaidAbsentBlowjob(this);
    this.fragments.handjob = new FarmerMaidAbsentHandjob(this);
    this.fragments.recover = new FarmerMaidRecover(this);

    this.subControllers = {};

    //this.bgm = new AudioController(id, "res/audio/varanar/noonthreestore.mp3", 100);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}
