/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTeeth(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.claws;
    var subController = ctrl.teeth;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidBrandmark(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While the searing pain still inhibits much rational thought,
                            your nerves calm a very little, believing your torment to be over.
                            Nothing could be further from the truth.
                            As your breathing starts to stabilize, you notice the men haven't [i]let go[/i] of you yet.
                            Are they [i]not[/i] finished yet?
                        [/p]
                        [p]
                            A pair of filthy hands finds its way inside of your gaping maw,
                            and spreads your jaws open wide.
                            You are far too worn out to resist.
                            Romeo shallowly presses one of his fingers into your muzzle,
                            rubbing the tips of the bottom row of your sharp teeth.
                            Giving a reaffirming nod to his [i]friends[/i], he ominously nears your mouth with the pliers.
                        [/p]
                        [p]
                            Realizing what is about to happen, you struggle as hard as you can, but your drug-weakened,
                            weary body is no match for the multitude of strong farmers holding you in place.
                            Even your jaws, otherwise extremely powerful,
                            with teeth capable of biting even through thin metal,
                            are easily overpowered by a single set of hairy, grimy fingers.
                            You are completely powerless to stop them,
                            and that fact hurts you far more than their torture ever could.
                            Or so you hope.
                        [/p]
                        [p]
                            Your owner clamps one of your sharp fangs in between the jaws of his pliers.
                            You audibly weep, shivering from pain, shock and trauma.
                            But he doesn't care.
                            Your claws were dangerous.
                            So are your teeth.
                            He can't let a [b]wild animal[/b] into his house without [i]disarming[/i] it first.
                            For all he knows, you could tear his son's throat out, or scar his wife for life.
                            And he's not going to let that happen.
                        [/p]
                        [p]
                            Romeo tormentingly wriggles your tooth about, so hard you fear he might [b]break it off[/b].
                            But that's not his plan.
                            He's merely [b]loosening[/b] it.
                            After a few agonizing moments, he [b]pulls[/b] backwards, [b]yanking[/b] the fang straight out of your mouth,
                            tearing the very roots of your tooth from your gums.
                            You [b]scream[/b] out in pain, louder than you have ever screamed before.
                            Your mouth floods with blood, which oozes from your muzzle, diluted with spit.
                        [/p]
                        [p]
                            This is hell.
                            You fell off the stage at the auction, broke your neck and [b]died[/b].
                            These [b]demons[/b] are torturing you.
                            Your head is tilted upwards, your own blood running down into your throat.
                            You have no choice but to swallow it.
                            Your second fang is taken in between the pliers.
                            At least this time he doesn't wriggle it around.
                            A single [b]tug[/b] sends a new soul-crushing wave of torment coursing throughout your body.
                            Another tooth lost.
                        [/p]
                        [p]
                            You are defanged.
                            But still they do not let go.
                            What more do they want?
                            Oh no.
                            The farmer you belong to wipes the blood off of his pliers,
                            before pressing them into your mouth once more.
                            This time, he takes hold of an incisor next to the hole where one of your fangs used to be.
                            Then you realize.
                            It's not just your fangs.
                            He wants to remove [b]all[/b] of your teeth.
                            With that thought, your mind goes blank once more, unable to cope with the situation at hand.
                        [/p]
                        [p]
                            You come to your senses halfway through your teeth-removal,
                            prodded awake by a [i]new[/i] type of pain.
                            Working on one of your back teeth, Romeo has accidentally placed his pliers too high.
                            Instead of clamping on to the molar he was aiming for, his tongs sink into your soft, sensitive gums.
                            Not realizing his mistake, he presses down hard with both of his hands,
                            [b]squeezing[/b] your flesh in between the two metal jaws hard enough to [b]draw blood[/b].
                            You let out an agonized gurgle, coughing up some of the various fluids pooling at the back of your throat.
                            Only after several seconds of [b]crushing[/b] your upper jawbone to the point of [b]shattering[/b] it,
                            does he readjust his grip, and manage to pull the tooth out in a single rip.
                        [/p]
                        [p]
                            While you, [i]sadly[/i], don't manage to have any more mini-black outs,
                            events somewhat start to blur together after your owner's [i]mishap[/i].
                            One tooth gets yanked out after the other, and before you know it, your entire mouth is empty and barren.
                            The scruffy fingers are removed from your mouth,
                            and your aching jaw can come to a rest.
                            You make the mistake of fully closing your mouth, pressing your bleeding gums against one another,
                            the sudden pain almost making you [b]choke[/b] on your own spit.
                        [/p]
                        [p]
                            As your head is let go of, you let it limply hang off your neck,
                            letting the blood seep from your muzzle onto the ground,
                            which is already running red from the liquid still spilling from your fingers and toes.
                            At least it's over.
                            It [b]is[/b] over, right?
                            There's nothing left of you to remove.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
