/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidMaid(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preMaid;
    var subController = ctrl.maid;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidResist(ctrl);
    var secondNext = new FarmerMaidAbide(ctrl);
    var thirdNext = new FarmerMaidEncourage(ctrl);

    var firstChoice = FarmerMaidMaidChoice.RESIST;
    var secondChoice = FarmerMaidMaidChoice.ABIDE;
    var thirdChoice = FarmerMaidMaidChoice.ENCOURAGE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The next morning,
                            you are awakened by the crowing of a rooster.
                            A feather duster and a broom lie on the floor, next to your basket.
                            Nobody's around but you.
                            You rise to your shaky, mangled feet.
                            Standing upright hurts, and you can [b]barely[/b] walk.
                            You consider fleeing, but you wouldn't get far like this.
                            Especially not with every villager in the hamlet keeping an eye out for you.
                        [/p]
                        [p]
                            That leaves three options.
                            You can make a mess of things, which will piss off your [i]master[/i] to the point where he'll probably [b]kill[/b] you.
                            While death seemed like a good alternative while you were being [i]tortured[/i],
                            right now you'd rather stay alive to see your wounds heal.
                            Alternatively, you could [b]refuse[/b] to work,
                            but given the hell you've been through already,
                            you're kind of [i]scared[/i] to think of what the human might do to you if you fail to live up to his expectations.
                            You can't take much more abuse.
                        [/p]
                        [p]
                            So, that leaves option number three: you clean.
                            As long as you do what your master expects of you,
                            he'll have no reason to [i]hurt[/i] you.
                            And you kind of [b]want[/b] that morsel of food he alluded to.
                            With that, your mind is made up.
                        [/p]
                        [p]
                            Bending down, you pick the broom up off the ground.
                            Gripping things with your fucked up fingers is painful,
                            but you manage to get a loose hold on the handle.
                            Swallowing what little of your pride you have left,
                            you deftly begin to sweep the wooden floor clean of dust, dirt and filth.
                            Due to your injuries, you can't really do a very good job,
                            but you try your best.
                        [/p]
                        [p]
                            Come dinner time, your dilligent efforts are rewarded.
                            You get a small piece of moldy old bread.
                            While your lack of teeth prevents you from [i]chewing[/i],
                            you let the stale, hard crust soak in your mouth,
                            until it disintegrates into pieces,
                            so you can swallow it down more easily.
                            While not much, it's [b]a lot[/b] better than nothing.
                        [/p]
                        [p]
                            The second day goes a lot like the first.
                            Your wounds are healing, your cleaning-technique steadily improving.
                            Growing accustomed to not having teeth, your speech also betters.
                            Another piece of moldy bread keeps you going.
                            The farmer's wife and son mostly ignore you.
                            You pick up their names by eavesdropping when they talk to one another.
                            Juliet and Falco.
                            Weird name for an eagle.
                            You don't dare bring it up, out of fear he'll take offence.
                        [/p]
                        [p]
                            Over the course of the week,
                            you listen in to multiple conversations,
                            trying to understand the [i]family dynamic[/i] between the bird and his [i]parents[/i].
                            From what you gather, Romeo and Juliet got together,
                            one day a bird came to visit,
                            and some time later Falco was born.
                            You don't know how a human gave birth to a bird,
                            but apparently that's what happened.
                            You wonder whether she laid an egg, or if it was a live birth.
                            Maybe he was [i]adopted[/i]?
                        [/p]
                        [p]
                            Near the end of your first week of proper [i]captivity[/i],
                            you notice the farmer's son starting to take an interest in you.
                            He begins to lounge around the house a lot more,
                            staring at you while you work.
                            At first, he tries to hide his curiosity from you,
                            looking away when you return his gaze.
                            As the days go by, he grows more bold.
                            He keeps his eyes fixed on you, sometimes for hours at a time.
                            At the start of the second week, you catch him outright [b]ogling[/b] you,
                            his eyes fixed on your exposed butt.
                        [/p]
                        [p]
                            The lecherous leering gradually becomes more and more commonplace.
                            Especially when you bend over to pick something up, the boy's eyes are trained on your backside.
                            Then, near the end of the second week, while cleaning one of the cabinets in the living room, the situation escalates.
                        [/p]
                        [p]
                            The avian rises from his seat on the couch,
                            and walks up right behind you,
                            his clothing-clad groin pressing into your bubbly rear.
                            You can feel his stiff member prodding against your butt through his pants.
                            Without a word, his hands roam to your chest, and he casually begins to molest your barely covered breasts,
                            his breath audibly growing heavier.
                            You don't know how old he is, but you doubt this is appropriate behavior for his age!
                            How do you react?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Resist</button>`;

        var tooltip = global.parser.parse(`Be firm, and tell the boy to stop.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Abide</button>`;

        var tooltip = global.parser.parse(`Let him have his fun. He'll grow tired of touching you soon enough.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 240px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Encourage</button>`;

        var tooltip = global.parser.parse(`Teach the kid a thing or two.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidMaidChoice = {
    RESIST: 1,
    ABIDE: 2,
    ENCOURAGE: 3
};
