/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidAbusiveLeave(ctrl);
    var secondNext = new FarmerMaidAbusiveWatch(ctrl);
    var thirdNext = ctrl.fragments.handjob;

    var firstChoice = ctrl.parentsChoice.LEAVE;
    var secondChoice = ctrl.parentsChoice.WATCH;
    var thirdChoice = ctrl.parentsChoice.HANDJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            About two and a half months into your forced servitude, you are awoken by loud arguing coming from the dining room.
                            Sleepily getting up to see what the trouble is all about, you find the farmer having a heated discussion with his wife,
                            while Falco sits and watches from across the table, a smug smirk plastered across his face as he slowly eats his breakfast-sandwich.
                            It seems you've arrived quite late,
                            the [i]argument[/i] rapidly escalating.
                            Curiosity getting the best of you, you listen in.
                        [/p]
                        [p]
                            "[color=ppink]I'm not seeing anyone, I swear![/color]"
                            pleads Juliet.
                            Her husband is having none of that, however.
                            "[color=red]I may be a simple farmer, but I'm not [b]stupid[/b]!
                            I [b]know[/b] what those stains on the back of your pants are from!
                            Now [b]tell me[/b] who it is, so I can [b]stab[/b] my rake through his heart![/color]"
                        [/p]
                        [p]
                            Oh dear.
                            It sounds like he's found a few hints of what his wife and son have been up to in his absence,
                            although he can't quite pin down the culprit yet.
                            You [i]sort of[/i] want to come clean, but you fear the man might misplace his rage, and turn on [b]you[/b] instead.
                            Plus, if the woman doesn't back you up, it'd be your word against Falco's.
                            And that's not an argument you think you'd win.
                        [/p]
                        [p]
                            "[color=ppink]It's [b]butter[/b]-stains![/color]"
                            His rage boiling over, the farmer harshly [b]slaps[/b] his wife, hard enough to [b]knock[/b] her to the floor.
                            She bursts out into tears, lying on her back while her husband looms over her.
                            Well, now you know where the eagle got his manners from.
                            "[color=red]I'll catch you one of these days,
                            and when I do, I'll kill you and your lover [b]both[/b]![/color]"
                            That said, he storms out of the back door, loudly [b]slamming[/b] it shut behind him.
                        [/p]
                        [p]
                            Juliet remains on the ground, crying her eyeballs out.
                            She clearly doesn't know [b]what[/b] to do anymore.
                            Her son rises from his seat, leaving his half-eaten breakfast on the plate.
                            He casually approaches the downed housewife.
                            For a moment, you think he might [i]help her up[/i], but he doesn't.
                            Instead, he steps over the woman, and then kneels down over her,
                            pinning the woman down by sitting ontop of her.
                        [/p]
                        [p]
                            Wasting no time and no words,
                            Falco yanks down his mother's top,
                            exposing her bountiful bosom.
                            Then, he begins to fiddle with his belt.
                            You've seen them mess around enough to know where this is going.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`Still not your business. Leave the room and pretend this never happened.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Watch</button>`;

        var tooltip = global.parser.parse(`Stay while the boy has his way with his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled} disabled>Jerk him off</button>`;

        var tooltip = global.parser.parse(`Offer a handjob to sate the kid instead. He wanted you initially, right? [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}
