/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.LEAVE;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.abusiveDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            How cruel of Falco to hop on his mother mere [b]moments[/b] after she was struck down.
                            This is not [i]your[/i] fight.
                            [b]She[/b] needs to push him off of her, to resist his advances like you did.
                            It's not up to you to settle her affairs for her.
                            You're a maid.
                            A [b]slave[/b].
                            It's not your duty to interfere.
                            But you can't stay and watch, either.
                        [/p]
                        [p]
                            You leave the room, closing the door behind you.
                            Ignoring the outright [b]rape[/b] happening in the house, you start your daily cleaning routine.
                            Over an hour later, the bird emerges from the dining room.
                            You still haven't wiped the dishes, a perfect excuse for you to head in there and see how Juliet is doing.
                        [/p]
                        [p]
                            She's lying on the floor, in the exact same spot she was as when you left her.
                            Her tits are coated in several layers of spunk, a thick trail of which leads all the way up her neck to her chin.
                            Falco must have used her body multiple times in a row.
                            Her face is covered in a few different fluids.
                            Cum, tears, is that [i]spit[/i]?
                            Poor woman.
                        [/p]
                        [p]
                            But you can't quite find it in your heart to feel truly compassionate for her.
                            She brought this upon herself.
                            All she had to do was say [b]no[/b].
                            If she'd told her son off the very first time he made a move,
                            then [b]none[/b] of this would have happened.
                            It's all her own fault!
                        [/p]
                        [p]
                            Disregarding the abused housewife,
                            you deftly go about your business.
                            You sweep dust off of the table,
                            you collect the plates,
                            brush off the crumbs and snag Falco's half-eaten sandwich for yourself,
                            and put them back in the cabinet where they belong.
                            Then, you leave the room once more,
                            without so much as asking Juliet whether or not she's okay.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
