/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BreedingBarn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var declineId = "barnOfferDeclineButton";
    var notBarnId = "barnOfferNotBarnButton";
    var eagerId = "barnOfferEagerButton";

    var toDecline = new NotBarnTea(ctrl);
    var toNotBarn = new NotBarn(ctrl);
    var toEager = new BarnEager(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[st]The barn[/st]
                        [p]
                            You head back up the trail a bit, and this time follow the [i]other[/i] path, the one leading towards the barn.
                            Even before you enter, the familiar smell of straw mixed with a less common fragrance,
                            one you can't quite put your finger on, creeps into your nose.
                            You walk up to the sizeable wooden door, and after another threefold-series of firm knocks,
                            you invite yourself into the barn,
                            the sturdy, yet ill-maintained door nearly falling off its hinges as you open it and close it behind you once more.
                        [/p]
                        [p]
                            [c]
                                <a href="scenes/HamletDay2/BreedingFarm/barn/barn-full.png" target="_blank">
                                    <img class="sfw" src="scenes/HamletDay2/BreedingFarm/barn/barn.png" title="Made by Sneaky">
                                </a>
                            [/c]
                        [/p]
                        [p]
                            While the outside looks decrepit, the inside of the barn looks rather tidy and neat,
                            besides the hay strewn about the flattened ground in a disorderly manner, but you suppose that's to be expected on a farm of sorts.
                            The vast main area is divided into two rows of large cubicles, one on either side of the barn.
                            In between these animal pens is a broad walkway filled with bales of hay and boxes of varying sizes.
                            On the far end of the barn, there stands a lone table, with a single stool next to it.
                        [/p]
                        [p]
                            The cubicles themselves are relatively new, judging by the far brighter tone of wood they are made of.
                            They must be a recent addition to this age-old structure.
                            All of them are closed, apart from a single one, all the way at the end of the walkway.
                            The cracks in between the planks are, sadly, not nearly big enough to see anything through.
                            While high enough for humans to gaze over the top of,
                            the exact species of animals contained within the enclosures remain a mystery to someone as [i]small[/i] as you are.
                        [/p]
                        [p]
                            You'd imagine such pens to contain feral horses or other big barnyard animals, yet you don't hear any animal noises.
                            You wonder what's in them.
                            Must be something small and silent, like rabbits maybe?
                            A rabbit breeding farm.
                            That [i]would[/i] make sense.
                            But why build a barn this big to keep rabbits in it?
                            Wouldn't they tunnel out?
                        [/p]
                        [p]
                            Just as you were about to climb up the side of one of the wooden walls to sate your curiosity,
                            a loud voice with a heavy western accent disturbs your train of thoughts:
                            [c][b]<span style="font-size: 30px;">[color=orange]Howdy, partner![/color]</span>[/b][/c]
                        [/p]
                        [p]
                            Out of the single open cubicle at the other end of the barn strides a half-naked anthromorphic vixen,
                            most of her lithe frame covered by nothing but pristine fur.
                            The only clothing she's wearing is a pair of ${global.kobold.inventory.createItemWithTooltip(new SpurredBoots())} 
                            and a large ${global.kobold.inventory.createItemWithTooltip(new CowboyHat())} that cutely flattens her ears.
                            ${global.kobold.history.shared.enslavement.captured ? `You think you saw her at the auction earlier,
                            although she's ditched her black shirt since.` : ``}
                            With a hearty smile on her face, she gives you a cheerful wave, before jogging towards you, her hefty,
                            furred breasts jiggling substantially with every graceful step she takes.
                        [/p]
                        [p]
                            As the woman nears you, her brisk running pace turns into a slow, elegant walk, 
                            bare hips swaying seductively back and forth, along with her tail.
                            Your eyes practically moving by themselves, you take a closer look at the female fox's body.
                            Her fur is a mixture of orange and white, with her extremities colored black.
                            Most of the front of her body, including her substantial bosom, her belly and her groin are all colored an immaculate white,
                            which you imagine runs all the way to the underside of her tail.
                        [/p]
                        [p]
                            [c]
                                ${global.ui.inlineImage.create("scenes/HamletDay2/BreedingFarm/img/intro", "png", ImageWidthEnum.CUSTOM, false, "Sneaky")}
                            [/c]
                        [/p]
                        [p]
                            You snap out of the dirty, daydreaming thoughts invading your mind as the woman extends her arm towards you,
                            grabbing your hand and shaking it eagerly.
                            You awkwardly fail to reciprocate her enthusiasm, but she doesn't seem to mind.
                            "[color=orange]I'm Cassidy! What do they call you?[/color]"
                            Still slightly enamored with her naked body, and awestruck by her lack of clothing, you barely manage to stammer out your name.
                            "[color=orange]${name}?
                            How cute!${global.kobold.history.shared.enslavement.captured ? `You're the one that was being sold earlier, if I'm not mistaken?` : ``}[/color]"
                            ${global.kobold.history.shared.enslavement.captured ? `You give the vixen a slight nod.
                            "[color=orange]I wish I was the one who took you home.
                            You look adorable enough to [b]eat[/b]![/color]"` : ``}
                        [/p]
                        [p]
                            The vixen lets go of your hand, instead placing her palm firmly atop your shoulder.
                            She bends down promiscuously, her cleavage almost pressing against your face.
                            She's so close you can [b]smell[/b] her, a faintly feminine fragrance mixing with the domineering scent of straw and hay.
                            Paralyzed with a mixture of anxiety and budding arousal, you stand perfectly still as she leans in,
                            pressing her furred muzzle against the scaly side of your face.
                            Then, she whispers, softly, ever so softly, yet her words pierce your mind like a crossbow bolt would your soft flesh.
                            "[color=orange][small]So, ${name}, have you ever [b]fucked[/b] a vixen before?[/small][/color]"
                        [/p]
                        [p]
                            Your jaw falls agape.
                            Your eyes open wide.
                            Closing your mouth, you swallow audibly.
                            Did she say what you [i]think[/i] she said?
                            A million thoughts race through your mind,
                            yet your mental panic is interrupted as the woman slides her tongue across your scales,
                            trailing a lick over the side of your face before aligning her muzzle with your own.
                            Pressing her soft, velvety lips against yours, she gives you a single, tender kiss.
                        [/p]
                        [p]
                            The vixen pulls away from the kiss, but keeps her face close to yours.
                            After a short moment of her lustfully licking her lips while staring into your eyes, she speaks yet again.
                            "[color=orange]Well then, what'll it be,
                            ${ctrl.misc.baseGender() === GenderEnum.MALE ? "my handsome little devil" : "you pretty little girl"}?[/color]"
                            She gestures behind her, as though inviting you deeper into the barn.
                            "[color=orange]There's a table in the back, and I've an [b]itch[/b] only something [b]small[/b] and [b]cute[/b] like you can scratch.[/color]"
                            ${global.kobold.history.shared.enslavement.captured ? `You're starting to regret not being bought by her.` : ``}
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the ant choice button.
     */
    function buildDeclineChoice() {
        var disabled = ctrl.barn.has() ? "disabled" : "";
        var isSelected = ctrl.barn.get() === BreedingBarnChoice.DECLINE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${declineId}" ${disabled}>Decline</button>`;

        var tooltip = `What? You've only just met, and she already wants to sleep with you? Something smells fishy.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the shake choice button.
     */
    function buildNotBarnChoice() {
        var disabled = ctrl.barn.has() ? "disabled" : "";
        var isSelected = ctrl.barn.get() === BreedingBarnChoice.NOTBARN;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${notBarnId}" ${disabled}>Not here</button>`;

        var tooltip = global.parser.parse(`What a freaky [i]bitch[/i].
                                           You can't say her proposal has left you uninterested, but you don't want to have sex in a filthy barn like this.
                                           Ask to go back to her place instead.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the shake choice button.
     */
    function buildEagerChoice() {
        var disabled = ctrl.barn.has() ? "disabled" : "";
        var isSelected = ctrl.barn.get() === BreedingBarnChoice.EAGER;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${eagerId}" ${disabled}>Accept</button>`;

        var tooltip = `Hot damn! Does she greet everyone this way?
                       Time to ${ctrl.misc.baseGender() === GenderEnum.MALE ? "take a ride on the town bicycle" : "show her exactly what kobold tongues are capable of"}.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildDeclineChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildNotBarnChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildEagerChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + declineId), $("#" + notBarnId), $("#" + eagerId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerDeclineListener() {
        $("#" + declineId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barn.set(BreedingBarnChoice.DECLINE);
            loadNextPart(toDecline);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerNotBarnListener() {
        $("#" + notBarnId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.barn.set(BreedingBarnChoice.NOTBARN);
            loadNextPart(toNotBarn);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerEagerListener() {
        $("#" + eagerId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            global.kobold.history.shared.cassidy.capturedby = true;
            ctrl.barn.set(BreedingBarnChoice.EAGER);
            loadNextPart(toEager);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "breedingBarn";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.arrival.get() !== BreedingFarmArrivalChoice.BARN) {
            return "";
        }
        global.ui.applyTheme("hamlet_barn");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += toDecline.build();
        part += toNotBarn.build();
        part += toEager.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.arrival.get() !== BreedingFarmArrivalChoice.BARN) {
            return;
        }

        toDecline.registerListeners();
        toNotBarn.registerListeners();
        toEager.registerListeners();

        if (ctrl.barn.has()) {
            return;
        }

        registerDeclineListener();
        registerNotBarnListener();
        registerEagerListener();
    };
}

var BreedingBarnChoice = {
    DECLINE: 1,
    NOTBARN: 2,
    EAGER: 3
};
