/**
 * Controller for the unsaved part of the home scene.
 * @param {string} sceneId The id of the scene.
 */
function HomeUnsavedController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var id = sceneId;

    var sexExId = "unsavedSexEx";
    var sleepId = "unsavedSleep";
    var groundId = "unsavedGround";
    var shakeId = "unsavedShake";
    var hammockChangeId = "unsavedHammockChange";
    var pillageChangeId = "unsavedPillageChange";
    var wetChangeId = "unsavedWetChange";
    var masturbateChangeId = "unsavedMasturbateChange";
    var antChangeId = "unsavedAntChange";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Makes the sleep choice.
     * @param {HomeUnsavedChoice} choice The choice.
     */
    this.makeSleepChoice = function (choice) {
        global.kobold.history.setKey(id, sleepId, choice);
    };

    /**
     * Fetches the sleep choice from history and returns it.
     * May return undefined if the sleep choice has not yet been set.
     */
    this.getSleepChoice = function () {
        return global.kobold.history.getKey(id, sleepId);
    };

    /**
     * Returns true if the sleep choice has been made.
     */
    this.hasMadeSleepChoice = function () {
        return global.kobold.history.has(id, sleepId);
    };


    /**
     * Makes the ground choice.
     * @param {HomeGroundChoice} choice The choice.
     */
    this.makeGroundChoice = function (choice) {
        global.kobold.history.setKey(id, groundId, choice);
    };

    /**
     * Fetches the ground choice from history and returns it.
     * May return undefined if the ground choice has not yet been set.
     */
    this.getGroundChoice = function () {
        return global.kobold.history.getKey(id, groundId);
    };

    /**
     * Returns true if the ground choice has been made.
     */
    this.hasMadeGroundChoice = function () {
        return global.kobold.history.has(id, groundId);
    };

    this.hammockChange = function () {
        global.kobold.history.doIfNotSet(id, hammockChangeId, true, function () {
            global.kobold.status.physical.decrease(10, "Near-hypothermia");
            global.kobold.status.stamina.increase(15, "Poor sleep");
            if (global.kobold.status.exertion.get()) {
                global.kobold.history.setKey(id, sexExId, true);
                global.kobold.status.exertion.decrease(20, "Slept");
            }
        });

        var changes = [
            new Change("Near-hypothermia", "Health", -10),
            new Change("Poor sleep", "Stamina", +15)
        ];
        if (global.kobold.history.has(id, sexExId)) {
            changes.push(new Change("Slept", "Sexual exhaustion", -20, true));
        }
        return global.ui.change.buildNotification(changes);
    };

    this.pillageChange = function () {
        global.kobold.history.doIfNotSet(id, pillageChangeId, true, function () {
            global.kobold.status.physical.increase(25, "Short nap");
            global.kobold.status.mental.increase(25, "Short nap");
            global.kobold.status.stamina.increase(25, "Short nap");
            if (global.kobold.status.exertion.get()) {
                global.kobold.history.setKey(id, sexExId, true);
                global.kobold.status.exertion.decrease(25, "Short nap");
            }
        });

        var changes = [
            new Change("Short nap", "Health", +25),
            new Change("Short nap", "Sanity", +25),
            new Change("Short nap", "Stamina", +25)
        ];
        if (global.kobold.history.has(id, sexExId)) {
            changes.push(new Change("Short nap", "Sexual exhaustion", -25, true));
        }
        return global.ui.change.buildNotification(changes);
    };

    this.wetChange = function () {
        global.kobold.history.doIfNotSet(id, wetChangeId, true, function () {
            global.kobold.status.physical.increase(15, "Brief nap");
            global.kobold.status.mental.increase(10, "Mental victory");
            global.kobold.status.stamina.increase(15, "Brief nap");
            global.kobold.status.exertion.increase(10, "Unsated lust");
        });
        return global.ui.change.buildNotification([
            new Change("Brief nap", "Health", +15),
            new Change("Mental victory", "Sanity", +10),
            new Change("Brief nap", "Stamina", +15),
            new Change("Unsated lust", "Sexual exhaustion", +10, true)
        ]);
    };

    this.masturbateChange = function () {
        global.kobold.history.doIfNotSet(id, masturbateChangeId, true, function () {
            global.kobold.status.physical.decrease(5, "Sleep deprivation");
            global.kobold.status.mental.decrease(5, "Sleep deprivation");
            global.kobold.status.stamina.decrease(5, "Sleep deprivation");
            global.kobold.status.exertion.increase(20, "Masturbation");
        });
        return global.ui.change.buildNotification([
            new Change("Sleep deprivation", "Health", -5),
            new Change("Sleep deprivation", "Sanity", -5),
            new Change("Sleep deprivation", "Stamina", -5),
            new Change("Masturbation", "Sexual exhaustion", +20, true)
        ]);
    };

    this.antChange = function (gender) {
        global.kobold.history.doIfNotSet(id, antChangeId, true, function () {
            global.kobold.status.physical.decrease(5, "Sleep deprivation");
            global.kobold.status.mental.decrease(10, "Fucked an anthill");
            global.kobold.status.stamina.decrease(10, "Fucked an anthill");
            global.kobold.status.exertion.increase(25, "Fucked an anthill");
            if (gender === GenderEnum.MALE) {
                global.kobold.body.growDick(global.kobold.body.dick + 1);
            } else {
                global.kobold.body.growBreasts(global.kobold.body.breasts + 1);
            }
        });

        var changes = [
            new Change("Sleep deprivation", "Health", -5),
            new Change("Fucked an anthill", "Sanity", -10),
            new Change("Fucked an anthill", "Stamina", -10),
            new Change("Fucked an anthill", "Sexual exhaustion", +25, true)
        ];

        if (gender === GenderEnum.MALE) {
            changes.push(new Change("Lasting effects", "Dick size", +1));
        } else {
            changes.push(new Change("Lasting effects", "Breast size", +1));
        }

        return global.ui.change.buildNotification(changes);
    };

    function ShakeController(key) {
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
    }

    this.shake = new ShakeController(shakeId);
}

