/**
 * Blowjob section of Varanar, Noon Three.
 * @param {NoonThreeStoreController} controller The Varanar, Noon Three controller.
 */
function NoonThreeStoreBlowjobAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.NoonThreeStoreMoneyChoice.ACCEPT;
    var reqController = ctrl.blowjobMoney;
    var subController = false;
    var changeController = false;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.blowjobChoices;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var hjEager = ctrl.handjobAttitude.get() === ctrl.NoonThreeStoreAttitudeChoice.EAGER;
        var baseGender = ctrl.misc.baseGender();
        var gender = baseGender === GenderEnum.MALE ? `boy` : `girl`;
        var toReturn = `[p]
                            Fine, but only because ${hjEager ? `he did that thing with his hand` : `you were [i]kind of[/i] rude to him before`}.
                            You're not doing this because you [b]like it[/b] or anything.
                            ${hjEager ? `That's a lie, and you both know it.` : `Far from it, in fact.`}
                        [/p]
                        [p]
                            You drop down to your knees, getting an up-close look at Rolande's [i]exotic[/i] member.
                            More of his ${hjEager ? `arousing` : `not-unpleasant`} scent floods your nostrils.
                            ${hjEager ? `You eagerly sniff the heady air,
                            taking in as much of it as you possibly can` : `You try to turn your head to face away and get some fresh air,
                            but the merchant keeps you in place`}.
                            "[color=yellow]That's a good ${gender}.
                            ${hjEager ? `I knew you couldn't resist` : `Let's not tarry now, you have something to make up for`}.[/color]"
                            ${hjEager ? `From where you're kneeling, it looks like he's the one who can't resist you` : `Douchebag`}.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
