

// SCENE FarmerMaid

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyStay.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyStay(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.STAY;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Stay with the bird, raise your child together.
                            Times change, kobolds get rights, live a happy life.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Dinosaur end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyStay.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyFree.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyFree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.LEAVE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Get set loose into the world.
                            Start a new life in the kobold district.
                            Single mom with baby, begging for scraps.
                            Get killed by random violence, very young child left alone in alleyway.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Full circle end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyFree.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyDad.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyDad(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preDeath;
    var subController = ctrl.death;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidDrunkSatisfyFree(ctrl);
    var secondNext = new FarmerMaidDrunkSatisfyStay(ctrl);

    var firstChoice = FarmerMaidDrunkSatisfyDadChoice.LEAVE;
    var secondChoice = FarmerMaidDrunkSatisfyDadChoice.STAY;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Dad dies.
                            Slave contract is technically with him.
                            Mom is too depressed to care.
                            Kid offers kobold choice between staying or leaving.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`You can't stay here. You'd only cause trouble for him in the long run.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Stay</button>`;

        var tooltip = global.parser.parse(`Let's raise the baby together, as a family.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidDrunkSatisfyDadChoice = {
    LEAVE: 1,
    STAY: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyDad.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkTrick.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkTrick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.TRICK;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.satisfied;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Trick the kid into pissing in your mop bucket.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkTrick.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkSatisfy.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfy(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkSatisfyDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Kid is pleased, starts letting you sleep in bed with him at night,
                            starts being less aggressive and cold, and more passionate about his lovemaking.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkSatisfy.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkPiss.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkPiss(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.PISS;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.satisfied;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Let the kid piss inside of you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkPiss.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineLick.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineLick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.LICK;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Lick the woman, repeat it for a few days.
                            Ultimately dog takes attention.
                            Dog starts licking woman.
                            Woman starts fucking dog.
                            Woman lets dog sleep with her.
                            You are more at peace.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Sub-canine end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineLick.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineDad.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineDad(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preDeath;
    var subController = ctrl.death;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidDrunkDeclineLick(ctrl);
    var secondNext = new FarmerMaidDrunkDeclineBite(ctrl);

    var firstChoice = FarmerMaidDrunkDeclineDadChoice.LICK;
    var secondChoice = FarmerMaidDrunkDeclineDadChoice.BITE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Dad dies.
                            Slave contract is technically with him, but kid nags mom to keep kobold around.
                            Dog starts pissing on kobold to mark his territory.
                            Kid has to work the fields now.
                            Mom gets more cruel.
                            Ultimately, mom starts sexually abusing kobold to make up for the lack of husband.
                            After a few days of exposition, fondling, fingering and groping, mom pulls kobold's head in between her legs (in living room).
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Lick</button>`;

        var tooltip = global.parser.parse(`Maybe she'll let you sleep in her bedroom, away from the dog.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Bite</button>`;

        var tooltip = global.parser.parse(`You may not have teeth, but your bare gums can still pinch things.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidDrunkDeclineDadChoice = {
    LICK: 1,
    BITE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineDad.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineBite.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.BITE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Bite the woman's clit, she screams out in pain, dog runs into the room and bites the kobold's neck, die.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Dogmeat end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineBite.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkGetHard.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkGetHard(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.HARD;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.dog;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Get the kid hard so he can't piss.
                            He gets angry and fucks off
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkGetHard.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDeclineDog.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineDog(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkDeclineDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Either kobold is so full of splinters that the kid no longer WANTS to fuck it,
                            or the kid is simply no longer interested in fucking the kobold.
                            The family gets a new dog, the kobold has to share its sleeping spot.
                            The kid lets the dog fuck the kobold.
                            It whines when it feels the splinters, and instead fucks the kobold's tailhole.
                            Perhaps this happens when tied up?
                            Maybe the dog starts fucking the kobold at night?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDeclineDog.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDecline.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDecline(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.DECLINE;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.dog;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Decline the kid. Forceful broom abortion.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDecline.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\FarmerMaidDrunk.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunk(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.drunk;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new FarmerMaidDrunkDecline(ctrl);
    var secondNext = new FarmerMaidDrunkGetHard(ctrl);
    var thirdNext = new FarmerMaidDrunkTrick(ctrl);
    var fourthNext = new FarmerMaidDrunkPiss(ctrl);

    var firstChoice = FarmerMaidDrunkChoice.DECLINE;
    var secondChoice = FarmerMaidDrunkChoice.HARD;
    var thirdChoice = FarmerMaidDrunkChoice.TRICK;
    var fourthChoice = FarmerMaidDrunkChoice.PISS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorRan = true;
        var toReturn = `[p]
                            Kid gets drunk one day, starts groping you and idly humping against you,
                            suddenly says to guide him in because he needs to take a leak.
                            "Don't want me to make a mess, do you?"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`Push him away. Tell him to go do his business outside. He might get [b]really upset[/b], though.
                                            He [b]is[/b] drunk, after all. You should probably [b]take a different approach[/b],
                                            unless you are ready to get [b]seriously hurt[/b].`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Get him hard</button>`;

        var tooltip = global.parser.parse(`He can't pee if he's erect. At least you hope he can't.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Trick him</button>`;

        var tooltip = global.parser.parse(`Squeeze his length with your thighs to make it seem like he's inside of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var disabled = subController.has()? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled}>Allow it</button>`;

        var tooltip = global.parser.parse(`Guide him in.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var FarmerMaidDrunkChoice = {
    DECLINE: 1,
    HARD: 2,
    TRICK: 3,
    PISS: 4
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\FarmerMaidDrunk.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarTell.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarTell(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.TELL;
    var reqController = ctrl.toofar;
    var subController = ctrl.toofarTell;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidTooFarFight(ctrl);
    var secondNext = new FarmerMaidTooFarServe(ctrl);

    var firstChoice = FarmerMaidTooFarTellChoice.FIGHT;
    var secondChoice = FarmerMaidTooFarTellChoice.SERVE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Having breakfast, dad fucks off to work the fields, mom leaves for Varanar,
                            left with kid alone, he threatens to tell parents unless you sate his lust.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Fight</button>`;

        var tooltip = global.parser.parse(`A fight to the death. You always knew it would come to this.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Serve</button>`;

        var tooltip = global.parser.parse(`Submit to the avian. You are, and always will be his slave.He just killed a full-grown human twice your size and three times your weight. What chance do you stand? None.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidTooFarTellChoice = {
    FIGHT: 1,
    SERVE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarTell.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarServe.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarServe(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarTellChoice.SERVE;
    var reqController = ctrl.toofarTell;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Get raped repeatedly by the avian, alongside his mother.
                            Get forced to eat her out and to rim him.
                            Become a sex slave.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Half-harem end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarServe.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarFight.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarFight(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarTellChoice.FIGHT;
    var reqController = ctrl.toofarTell;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Fight the kid, lose and die.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Defanged end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarFight.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarRun.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarRun(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.CONFRONT;
    var reqController = ctrl.toofar;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Run away from the farmer's home.
                            The world as you know it has changed.
                            Get shot by a rifle? Jump off a bridge and kill yourself? Probably the latter. Javert.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Miserable end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarRun.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarConfront.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarConfront(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.CONFRONT;
    var reqController = ctrl.toofar;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Confront the kid, you get beaten daily now instead of mom.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Punching bag end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarConfront.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFar.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFar(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.toofar;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidTooFarRun(ctrl);
    var secondNext = new FarmerMaidTooFarTell(ctrl);
    var thirdNext = new FarmerMaidTooFarConfront(ctrl);

    var firstChoice = FarmerMaidTooFarChoice.RUN;
    var secondChoice = FarmerMaidTooFarChoice.TELL;
    var thirdChoice = FarmerMaidTooFarChoice.CONFRONT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the year,
                        [/p]
                        [p]
                            Maybe he was getting [i]bored[/i] with regular sex.
                            Or perhaps he's hoping to [b]beat[/b] the child out of her before it gets born.
                            You don't know.
                            Honestly, you don't care.
                            You have 
                        [/p]
                        [p]
                            Kid goes too far, starts openly beating his mom, catch her pummeling her face.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Run away</button>`;

        var tooltip = global.parser.parse(`Use the lack of attention to slip away from the house, and escape your duties.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Tell dad</button>`;

        var tooltip = global.parser.parse(`Inform the father of the family of his son's [i]wild[/i] behavior.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Confront him</button>`;

        var tooltip = global.parser.parse(`Get in between the kid and his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidTooFarChoice = {
    RUN: 1,
    TELL: 2,
    CONFRONT: 3
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFar.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendKill.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendKill(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendJealousChoice.KILL;
    var reqController = ctrl.jealous;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Sneak into their room with a knife. Kill the girlfriend while she's riding his dick.
                            Push her off, press the knife to his throat and ride away.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Tsundere end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendKill.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendJealous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendJealous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var reqController = ctrl.girlfriend;
    var subController = ctrl.jealous;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendFrame(ctrl);
    var secondNext = new FarmerMaidGirlfriendKill(ctrl);

    var firstChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var secondChoice = FarmerMaidGirlfriendJealousChoice.KILL;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Grow resentful of the girl.
                            She's mean and talks down to you.
                            Have to get rid of her somehow.
                            But how?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Frame her</button>`;

        var tooltip = global.parser.parse(`Make it seem like she's sleeping around. Once there's trouble in paradise, you can make your move.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Kill her</button>`;

        var tooltip = global.parser.parse(`You don't think the bird's a necrophile. He'll be all yours once she's out of the picture.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendJealousChoice = {
    FRAME: 1,
    KILL: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendJealous.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendUsurp.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendUsurp(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendFrameChoice.USURP;
    var reqController = ctrl.frame;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Master kicks girlfriend out.
                            Approach him while he's jerking off and straddle his dick.
                            Become his girlfriend.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Eagle end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendUsurp.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendFrame.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendFrame(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var reqController = ctrl.jealous;
    var subController = ctrl.frame;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendUsurp(ctrl);
    var secondNext = new FarmerMaidGirlfriendCapture(ctrl);

    var firstChoice = FarmerMaidGirlfriendFrameChoice.USURP;
    var secondChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Steal underwear from neighbours, plant evidence.
                            "Discover" them together with the bird.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Usurp her</button>`;

        var tooltip = global.parser.parse(`Boot her out. Take her place. Become the girlfriend.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Capture her</button>`;

        var tooltip = global.parser.parse(`Keep her around. Make her clean for you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendFrameChoice = {
    USURP: 1,
    CAPTURE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendFrame.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendCapture.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendCapture(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;
    var reqController = ctrl.frame;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Master keeps her around as a fucktoy. You get to boss her around and make her do your chores. You also get to abuse her.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Fortune reversal end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendCapture.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriendAccept.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.ACCEPT;
    var reqController = ctrl.girlfriend;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Accept your place as their maid. Live out your live as a servant. As they grow older, they start somewhat respecting you.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Maid end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriendAccept.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriend.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriend(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.girlfriend;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendJealous(ctrl);
    var secondNext = new FarmerMaidGirlfriendAccept(ctrl);

    var firstChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var secondChoice = FarmerMaidGirlfriendChoice.ACCEPT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Kid gets a girlfriend, less pressure on you, he mostly leaves you alone.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Grow jealous</button>`;

        var tooltip = global.parser.parse(`Why should that bitch get to hog the bird all to herself?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Accept your place</button>`;

        var tooltip = global.parser.parse(`Being a maid without getting harassed all the time has its perks.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendChoice = {
    JEALOUS: 1,
    ACCEPT: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriend.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousThigh.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousThigh(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.NOPEN;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.amorousDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Listen, you can't just let him fuck you.
                            The bird's face sours, but you interrupt him before he manages to start pouting.
                            But there [i]is[/i] something pretty good that you can show him.
                            Something the two of you haven't tried yet.
                        [/p]
                        [p]
                            You approach the boy,
                            and grab on to his solid, quivering cock.
                            "[color=yellow]Not [i]another[/i] handjob. That's [b]boring[/b]![/color]"
                            You tell him to calm down, and to keep his voice down before his parents hear you.
                            You're not going to give him a handjob.
                            You promise.
                        [/p]
                        [p]
                            Slowly shuffling forwards,
                            you rest the boy's member against the entire length of your slit,
                            the top half slightly parting your folds.
                            Then, once properly positioned, you [b]squeeze[/b] down on his shaft with your thighs,
                            enveloping his meat with your soft scales and warm flesh, forming an intercrural hole for him to fuck.
                        [/p]
                        [p]
                            And fuck it, he does.
                            Without even waiting for your directions, the avian follows his instincts,
                            grabbing your ass to keep you in place, while rapidly rolling his hips back and forth,
                            outright [b]humping[/b] your thighs,
                            the head of his cock pleasurably travelling up and down your slit,
                            [b]massaging[/b] your folds.
                        [/p]
                        [p]
                            Never having felt this type of pleasure before, it doesn't take long for Falco to reach his end.
                            He doesn't simply squirt his load atop your scales like you hope he would, however.
                            Instead, he [b]shoves[/b] you away from him, forcing you to sit down on a nearby chair to catch your balance.
                            He approaches, and spreads your legs, ominously pressing the foreskin-covered tip of his length against your cunt.
                        [/p]
                        [p]
                            You [b]plead[/b] for him [b]not[/b] to fuck you,
                            but luckily that doesn't seem to be his plan.
                            Instead,
                            he jerks himself off, while rubbing his cockhead up and down your slit, relishing in the warmth.
                            Phew.
                            You almost thought he was about to [b]rape[/b] you.
                            But as long as he doesn't cum inside, it's all good.
                        [/p]
                        [p]
                            Too bad for you, the bird is too lost in pleasure to follow your directions.
                            Instead of blowing his load on your abdomen,
                            he pushes the tip of his member inside of you, right as he reaches his end.
                            Before you can even protest, you can already feel the first squirt of fertile spunk flooding your insides.
                            You [b]beg[/b] him to pull out, you even [b]struggle[/b] a little,
                            but he deftly keeps you in place while the contents of his hefty balls empty inside of you.
                        [/p]
                        [p]
                            Once finished, he casually pulls out of you, tugs up his pants, and leaves the room,
                            going about his daily business while leaving you with a cum-leaking cunt and the terrifying thought that he might have impregnated you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousThigh.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousFuck.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousFuck(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.FUCK;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.amorousDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            Okay, fine.
                            But only this once, alright?
                            And he [b]has[/b] to cum outside.
                            You getting pregnant would be a [b]very[/b] bad thing to happen,
                            for the [b]both[/b] of you.
                        [/p]
                        [p]
                            You lean against a wall, and casually lift your tail,
                            exposing your loins and your savory backside to the aroused bird boy.
                            He eagerly approaches you from behind, and presses the foreskin-covered tip of his member against your slit,
                            rubbing it up and down, parting your folds ever so slightly while slathering around copious amounts of precum,
                            slickening your passage to ease his insertion.
                        [/p]
                        [p]
                            "[color=yellow]I knew from the very first moment I saw you at that auction.[/color]"
                            The avian speaks, whilst teasing you with his length.
                            You playfully ask [i]what[/i] he knew.
                            "[color=yellow]That you were a [b]slut[/b] lusting for [b]big bird cock[/b].[/color]"
                            Without giving you the chance to even process his words,
                            the eagle [b]rams[/b] himself forwards,
                            drawing a loud moan from your lips as he spears your folds wide open,
                            hilting himself inside of you.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                        [/p]
                        [p]
                            He covers your muzzle with one of his feathery hands,
                            preventing you from alerting his parents with your cries of pleasure.
                            His other hand finds its way atop your thigh,
                            keeping you steady while he starts to [b]thrust[/b],
                            every powerful roll of his hips sending spikes of [b]pleasure[/b] down your spine.
                            For a teenager, he sure does know how to [b]fuck[/b].
                            Must be a natural talent that runs in his blood.
                            Maybe that's how his [i]real[/i] father seduced Juliet.
                        [/p]
                        [p]
                            As Falco's humping intensifies,
                            you get pushed close and closer to the wall,
                            your arms and legs both growing weak from pleasure.
                            His grints echo throughout the dining room.
                            He's almost as loud as his [i]human[/i] dad, upstairs.
                            The whorish sounds of his mother trump all, however.
                            She's [b]screaming[/b] in ecstacy loud enough for the entire hamlet to hear!
                        [/p]
                        [p]
                            You can't tell whether or not the eagle is fantasizing about his mother,
                            but either way, his end soon approaches.
                            You can feel his member starting to quiver inside of you.
                            The rational part of your brain [b]begs[/b] for you to ask him to pull out,
                            but it's too late.
                            You can already feel the first squirt of his fertile spunk flooding your insides.
                            The bird keeps himself hilted, while the contents of his hefty balls empty inside of you.
                        [/p]
                        [p]
                            Once finished, he casually pulls out of you, tugs up his pants and leaves the room,
                            going about his daily business while leaving you with a cum-leaking cunt and the terrifying thought that he might have impregnated you.
                        [/p]`;

        if (virgin) {
            toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousFuck.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunk(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var thigh = ctrl.parents.get() === ctrl.parentsChoice.NOPEN;
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = ``;

        if (thigh) {
            toReturn += `
                        [p]
                            From that day onwards,
                            Falco starts thighfucking you on a regular basis.
                            Every single time, despite your protests,
                            he ends up jerking off against your cunt, pushing his member inside of you, and blowing his load there.
                            Over the course of several weeks,
                            thighsex gradually turns into the bird jerking off while inserting his tip into your cunt.
                        [/p]
                        [p]
                            It isn't long until he starts putting more and more of himself inside of you.
                            No longer able to rub himself with his entire shaft lodged up your slit,
                            he begins to move back and forth.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                            You complain, but he doesn't listen.
                            And every single time, he fills you up with his potent seed.
                            After a dozen orso times of outright having sex,
                            you simply stop objecting.
                        [/p]
                        [p]
                            Falco takes the lack of complaints as a sign that you want this every bit as much as he does.
                            He starts to fuck you [b]properly[/b], humping the shit out of you while his hands toy with your body.
                            At first, you are [b]not[/b] into it in the slightest,
                            but as the avian grows more and more skilled in the art of making love,
                            your body begins to submit to him.
                            Your own urges grow more intense with every passing day.
                            You slowly grow to [b]like[/b] having sex with him.
                            And not long after that, you begin to [b]crave[/b] his daily dicking.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            From that day onwards,
                            Falco starts fucking you on a regular basis.
                            Every single time, despite your protests,
                            he ends up blowing his load inside of you.
                            After a dozen orso times of him cumming inside of you,
                            you simply stop objecting.
                        [/p]
                        [p]
                            Falco takes the lack of complaints as a sign that you want this every bit as much as he does.
                            His mind emboldened, he starts to fuck you [b]properly[/b], humping the shit out of you while his hands toy with your body.
                            At first, you are still kind of hesitant of letting him [i]impregnate[/i] you,
                            but as the avian grows more and more skilled in the art of making love,
                            your body begins to submit to him.
                            Your own urges grow more intense with every passing day.
                            You slowly grow to [b]like[/b] the idea of being [i]bred[/i] by him.
                            And not long after that, you begin to [b]crave[/b] his daily dicking.
                        [/p]`;
        }

        toReturn += `   [p]
                            By the end of the eighth month of your stay,
                            the eagle and you wantonly fuck all over the house whenever you please.
                            In the kitchen, in the den, in his room, on his parents' bed.
                            He even takes you out to the shack out back once or twice,
                            to showcase his father's collection of farming equipment while he pounds you bent-over a workbench.
                        [/p]
                        [p]
                            One night, failing to get any sleep, you rise from your dog-basket.
                            Your loins are [b]burning hot[/b] and [b]dripping wet[/b].
                            Come to think of it, you hadn't had any [i]fun[/i] with Falco that day.
                            He went out to explore the area with his friends,
                            and by the time he got back, he was so tuckered out that he slinked away to bed and fell asleep.
                            A wicked idea crosses your mind.
                            It's time to be a naughty girl.
                        [/p]
                        [p]
                            You rise to your feet, and silently slip up the stairs.
                            Opening the door to the bird's room, you step inside.
                            You crawl under the blankets covering him, and dutifully begin to caress, lick and suck his flaccid member, until he's nice and hard.
                            Then, you awaken the bird by tugging his warm cover off of him, exposing his naked body to the cold midnight air.
                            Before he even realizes what's going on, you lower your needy cunt onto his length,
                            and begin to ride him like a vixen in heat.
                        [/p]
                        [p]
                            Needing to stay quiet to avoid his parents waking up adds an extra layer of excitement to sex.
                            The creaking of his bed resonates throughout the room, louder than your combined, stifled moans and grunts.
                            You fuck until dawn, milking the spunk from his cock several times.
                            Right before his parents wake up, you sneak back into your basket downstairs, and pretend to be asleep.
                        [/p]
                        [p]
                            During the tenth month, you start feeling a little [i]off[/i].
                            You kind of think you might be [i]pregnant[/i].
                            But you don't let it show.
                            The two of you keep seeing eachother like normal.
                            One day, he returns your midnight surprise,
                            making his way to your basket to wake you up for some starlight-lit doggy style sex.
                            Sure as heck beats sleeping.
                        [/p]
                        [p]
                            Whenever your avian [i]lover[/i] sleeps in, you head up to his room to service his ever-present morning wood.
                            A great way to wake up, he agrees.
                            Although you can't do it [i]every[/i] day, lest his parents start to realize what's going on between the two of you.
                            Luckily, they seem oddly absent-minded, as of late.
                            You think the romance in [b]their[/b] life is flaring up as well.
                            More than once, Juliet goes to [i]visit[/i] her husband while he's working the farmland.
                            It's pretty obvious that Romeo is planting his seeds in more than one way.
                        [/p]
                        [p]
                            Come the eleventh month, things between Falco and you start getting a little bit more [i]kinky[/i].
                            He fucks your feet, cums in your armpits, makes you eat his sweaty,
                            feathery ass and sometimes even demands you lick his foot-talons.
                            You oblige to his every demand, doing everything to keep the father of your gestating baby a happy man.
                            You haven't told him yet, but it's slowly starting to show.
                            Your maid outfit can conceal your pregnancy still, but your slightly chubby belly is a dead giveaway when naked.
                        [/p]
                        [p]
                            Near the final month of the first year of your stay,
                            the eagle starts fucking your [b]ass[/b] instead of your cunt.
                            It hurts, at first.
                            It hurts [b]a lot[/b], in fact.
                            But for him, you grit your teeth and bear it.
                            It's a far tighter fit than your fucked-loose twat,
                            or so he comments.
                            And indeed, he cums rather quickly, filling your bowels with his warm, heady spunk,
                            before pulling out of your sensitive, slightly gaping tailhole and leaving you to clean yourself up.
                        [/p]
                        [p]
                            Approaching the end of the first year, you finally break the news to him.
                            You're pregnant.
                            And you're pretty sure the child is his.
                            No response.
                            Thinking he might not have heard you, you repeat your statement.
                            "[color=yellow]I heard you fine the first time.[/color]"
                            Well, what's he going to do about this?!
                            "[color=yellow]I need time to think.
                            For now, let's just keep doing it up your ass for a while.[/color]"
                        [/p]
                        [p]
                            He completely misses the point.
                            You sigh in exasperation.
                            The two of you end up angrily buttfucking for the remainder of the day.
                        [/p]`;

        if (thigh && virgin) {
            toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
        }

        toReturn += `   [p]
                            [todo]To be continued.[/todo]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled} disabled>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = ctrl.fragments.blowjob;
    var secondNext = new FarmerMaidAmorousThigh(ctrl);
    var thirdNext = new FarmerMaidAmorousFuck(ctrl);

    var firstChoice = ctrl.parentsChoice.BLOWJOB;
    var secondChoice = ctrl.parentsChoice.NOPEN;
    var thirdChoice = ctrl.parentsChoice.FUCK;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the week,
                            right after breakfast,
                            the man of the house gives his wife a sultry wink.
                            She knows well enough what that means.
                            Like Falco and you retreat to his room to have fun,
                            so too do his parents go to [i]their[/i] bedroom.
                        [/p]
                        [p]
                            But while you try to keep your voices down during your [i]fun[/i],
                            Romeo and Juliet don't seem to care who hears them.
                            The woman's pleasured screams echo throughout the entire house,
                            and the rhythmic squeaking of wood can be heard all the way at the dinner table.
                        [/p]
                        [p]
                            Your avian friend is intrigued by his mother's overly loud excitement.
                            He says that he wants to do what they're doing.
                            Right here, and right now.
                            You voice your worries that you might be [i]caught[/i],
                            but he simply unbuckles his pants, and pulls out his fully erect member,
                            before wisely retorting that with his parents upstairs,
                            nobody's around to [i]catch[/i] you.
                            And it's not like they'd hear you over their own [i]sounds[/i].
                        [/p]
                        [p]
                            It looks like the bird has made up his mind.
                            He [b]really[/b] wants this.
                            Do you relent, and let him fuck you?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled} disabled>A blowjob</button>`;

        var tooltip = global.parser.parse(`It's not what he wants, but surely he'll be satisfied with your mouth, right? [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Thighsex</button>`;

        var tooltip = global.parser.parse(`He can rub it against your slit, but putting it in is one step too far.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Actual sex</button>`;

        var tooltip = global.parser.parse(`It'd be cruel to deny the boy, with all the noise coming from upstairs.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You give him:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorous.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidPreAmorous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAmorous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAmorous(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The next day, right after Romeo and Juliet have left the house,
                            their son approaches you once more.
                            He doesn't speak, but what he wants couldn't be any more clear.
                            You've got something even [b]better[/b] for him, though.
                            You lift your skimpy maid-dress, and spread your legs ever so slightly,
                            giving the avian a close-up look at your feminine slit.
                        [/p]
                        [p]
                            He seems completely [b]enthralled[/b].
                            Without even asking, he reaches out and immediately begins to touch, rub and prod your sensitive folds.
                            Right as you were about to tell him to [b]finger[/b] you,
                            you hear the backdoor opening.
                            Damnit, can't you get [b]any[/b] privacy in this house?!
                            The boy scrambles upstairs, and you swiftly return to cleaning.
                            Romeo had forgotten his rake, which you spent most of last night cleaning.
                            Dumb farmer, interrupting your fun.
                        [/p]
                        [p]
                            Most of the later half of your first month of enslavement goes in a similar fashion.
                            Every day, Falco and you try something new, and almost every time you get interrupted.
                            Be it a neighbour knocking at the door,
                            his mother calling him,
                            or Romeo checking up on you during the day,
                            there's [b]always[/b] someone around to ruin the [i]fun[/i].
                        [/p]
                        [p]
                            The two of you are left flustered, panting and disappointed almost a dozen times over.
                            But the sheer [b]excitement[/b] of what you are doing keeps you going.
                            Likewise, a mixture of curiosity and arousal make him keep coming back for more.
                            Despite adversity, your escapades continue.
                        [/p]
                        [p]
                            The few sparse times you [b]don't[/b] get forced apart,
                            you manage to have a [b]great[/b] time together.
                            You let him touch every part of your body,
                            you let him experiment and figure out how many feathery fingers he can fit inside of your cunt,
                            and you even steal what you believe to be his very first [b]kiss[/b].
                        [/p]
                        [p]
                            Entering the second month of your servitude, the two of you devise a plan.
                            A way to fool around without constant interruptions.
                            He'll keep his own room clean, so when it comes time for [b]you[/b] to sweep it,
                            the two of you can have some fun together instead.
                            And nobody will be the wiser.
                            If anything, his parents will praise him for being so [b]dilligent[/b],
                            and for helping you with your tasks.
                            If they even care enough to notice, that is.
                        [/p]
                        [p]
                            Apart from a few minor interruptions,
                            the scheme seems to work exceptionally well!
                            Finally, you get to spend some [b]quality time[/b] together.
                            Over the course of the week, he fingerfucks all three of your holes,
                            the two of you sloppily make out atop his bed while he fondles your chest,
                            and you even let him eat you out once or twice.
                        [/p]
                        [p]
                            A spark of [b]passion[/b] growing between the two of you,
                            things rapidly grow more intense.
                            During the sixth week of your stay,
                            you encourage Falco to start [b]masturbating[/b] while the two of you are together.
                            Before, he'd always politely waited until you had left, to jerk off to the memory of your naked body,
                            and your taste lingering on his tongue.
                            But now, with your blessing, he is free to rub his dick in your presence.
                            And he gladly does so, eagerly tugging his shaft while exploring your body.
                        [/p]
                        [p]
                            Falco's uncut humanoid member is quite a bit [i]bigger[/i] than what you had expected.
                            Perhaps he's older than you imagined him to be.
                            Must be that bird thing Seki told you about.
                            As the eagle visibly gets close to cumming,
                            you move your hand to the tip of his member,
                            cupping his glans as he reaches his end,
                            letting him squirt his hefty load all over your scaly palm.
                            Can't let it get on the bed, or it'll stain.
                            Shooting the avian a sly look,
                            you lap his semen off your scales with a single stroke of your tongue,
                            and lewdly swallow it down.
                        [/p]
                        [p]
                            Your [i]lesson[/i] on not staining his bedsheets -- or your maid outfit, for that matter -- leaves a lasting impression.
                            From that day onwards, the bird finishes on you whenever he can.
                            Your ass, your face, your back and your chest all get coated in heady, pearly white spunk.
                            You even lend him a hand a few times, stroking his length for him, so he can use [b]both[/b] of his hands to toy with your body.
                            The best of this all is how [b]oblivious[/b] Romeo and Juliet are.
                            As far as they are concerned, their son a good boy that helps you clean his room on a daily basis.
                            Idiots.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidPreAmorous.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveWatch.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveWatch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.WATCH;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.abusiveDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            How cruel of Falco to hop on his mother mere [b]moments[/b] after she was struck down.
                            This is not [i]your[/i] fight.
                            [b]She[/b] needs to push him off of her, to resist his advances like you did.
                            It's not up to you to settle her affairs for her.
                            You're a maid.
                            A [b]slave[/b].
                            It's not your duty to interfere.
                            But you [b]do[/b] intend to stay and watch.
                            You know, to make sure he doesn't [i]hurt[/i] her.
                        [/p]
                        [p]
                            The bird reaches into his pants, producing his rock-hard humanoid length.
                            Hovering the uncut tip in front of Juliet's face, he slowly begins to stroke it,
                            rubbing the foreskin back and forth along his glans with every motion of his feathery hand.
                            "[color=yellow]You [b]love[/b] big bird cock, don't you, you [b]whore[/b]?![/color]"
                            That's no way to talk to his mother, but you're a spectator, not a [i]commentator[/i].
                            "[color=yellow]Else you wouldn't have fucked my [b]real[/b] dad behind Romeo's back.[/color]"
                            Oof.
                            He's got a point there.
                        [/p]
                        [p]
                            Noticing the human isn't in a very talkative mood,
                            the eagle lowers his member in between her breasts,
                            using both of his hands to press her boobs together,
                            enveloping his shaft with their warmth.
                            Then, he begins to thrust, outright [b]fucking[/b] his mother's tits,
                            humping away at her chest while constantly belittling her.
                            "[color=yellow]Dumb little hen.
                            I should [b]rip[/b] your pants next time.
                            Let's see you weasel your way out of that.[/color]"
                        [/p]
                        [p]
                            He roughly slaps her,
                            spits in her face,
                            rubs his balls clean on her head and constantly fiddles with her groin.
                            He finishes once on her chest, but rapidly jerks himself to full mast once more,
                            continuing to abuse Juliet for the better half of an hour.
                            Only then, while taking a small [i]break[/i] from the constant groping and humping,
                            does Falco even [b]realize[/b] that you are still in the room.
                            He glares angrily at you.
                            "[color=yellow]Get out of here, [b]slave[/b], unless you want some of my dick, too.[/color]"
                        [/p]
                        [p]
                            Returning his angry look, you let out a dignified huff before leaving the room,
                            resigning the human to the fate she herself chose.
                            Her son continues to abuse her for nearly an hour more,
                            before finally emerging from the dining room,
                            leaving her lying on the floor in a puddle of his spunk.
                            But that's none of your business.
                            You're here to clean, and clean you do.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveWatch.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveLeave.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.LEAVE;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.abusiveDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            How cruel of Falco to hop on his mother mere [b]moments[/b] after she was struck down.
                            This is not [i]your[/i] fight.
                            [b]She[/b] needs to push him off of her, to resist his advances like you did.
                            It's not up to you to settle her affairs for her.
                            You're a maid.
                            A [b]slave[/b].
                            It's not your duty to interfere.
                            But you can't stay and watch, either.
                        [/p]
                        [p]
                            You leave the room, closing the door behind you.
                            Ignoring the outright [b]rape[/b] happening in the house, you start your daily cleaning routine.
                            Over an hour later, the bird emerges from the dining room.
                            You still haven't wiped the dishes, a perfect excuse for you to head in there and see how Juliet is doing.
                        [/p]
                        [p]
                            She's lying on the floor, in the exact same spot she was as when you left her.
                            Her tits are coated in several layers of spunk, a thick trail of which leads all the way up her neck to her chin.
                            Falco must have used her body multiple times in a row.
                            Her face is covered in a few different fluids.
                            Cum, tears, is that [i]spit[/i]?
                            Poor woman.
                        [/p]
                        [p]
                            But you can't quite find it in your heart to feel truly compassionate for her.
                            She brought this upon herself.
                            All she had to do was say [b]no[/b].
                            If she'd told her son off the very first time he made a move,
                            then [b]none[/b] of this would have happened.
                            It's all her own fault!
                        [/p]
                        [p]
                            Disregarding the abused housewife,
                            you deftly go about your business.
                            You sweep dust off of the table,
                            you collect the plates,
                            brush off the crumbs and snag Falco's half-eaten sandwich for yourself,
                            and put them back in the cabinet where they belong.
                            Then, you leave the room once more,
                            without so much as asking Juliet whether or not she's okay.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveLeave.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidTooFar(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            For the remainder of the month,
                            you frequently stumble upon Falco enjoying his reluctant mother's body,
                            be it jerking off to her naked frame, fucking her tits,
                            fingering her cunt,
                            or even sloppily kissing her while forcing her to stroke him.
                            Often times, Juliet can be found wandering around the house covered in her son's spunk,
                            no longer bothering to clean herself during the day.
                            Instead, she douses herself with a bucket of water fetched from the well, once per evening, 
                            to wipe off any traces of the entire day's worth of bird jizz.
                        [/p]
                        [p]
                            Her tactic seems somewhat effective.
                            Romeo no longer complains about her [i]sleeping around[/i].
                            Whether that means he simply no longer [i]cares[/i],
                            or if he simply can't notice the smell of semen lingering about his wife,
                            you don't know.
                            He isn't around very often anyway.
                            Always absent.
                            Always working.
                        [/p]
                        [p]
                            The bird's lust gradually intensifies.
                            For a few months, he explores every part of Juliet's frame with his cock,
                            indulging in various sick and twisted kinks.
                            You catch him rubbing against and fucking her armpits,
                            forcing her to wrap her bare feet around his length,
                            cumming into her panties,
                            making her lick his feathery behind,
                            and commanding her to lap his spunk off the floor.
                        [/p]
                        [p]
                            Near the half-year mark,
                            things escalate even further.
                            Falco discovers the pleasure of a warm, wet mouth.
                            At first, he only makes his mother lick him,
                            but this soon transitions into regular blowjobs.
                            Come the seventh month of your stay,
                            the eagle outright [b]facefucking[/b] his mom becomes an everyday occurrence.
                        [/p]
                        [p]
                            Her cunt is the next hole he defiles.
                            The first time the feathery bastard musters up the courage to outright [b]fuck[/b] the woman that gave birth to him, 
                            she loudly [b]begs[/b] him to stop.
                            But she doesn't back.
                            She doesn't struggle.
                            And he doesn't listen, carelessly [b]ramming[/b] his member into Juliet,
                            pounding her like a man possessed, driven wild by [b]pleasure[/b] and [b]lust[/b].
                        [/p]
                        [p]
                            The next time you find them together,
                            the woman [b]begs[/b] her son to put on a specialized tool she'd brought from Varanar, especially for him.
                            A thin membrane carved from some kind of animal organ.
                            A [i]condom[/i], she calls it.
                            The boy reluctantly agrees.
                            After they're done, he makes her clean the insides of it with her mouth.
                        [/p]
                        [p]
                            From what you can gather from your eavesdropping, it apparently [i]wasn't[/i] as good as doing it [b]naturally[/b].
                            Still, she asks him to put it on every single time.
                            Since that shoddy first experience, he almost never listens, fucking her raw dozens of times,
                            shooting his fertile, crossbreed-capable sperm deep inside of her.
                            After more than a month of trying, the woman relents, ceasing her efforts to stave off pregnancy.
                            She stops offering her son condoms, instead reluctantly letting him do as he pleases.
                        [/p]
                        [p]
                            Around your tenth month at the farmer's home,
                            Falco claims the final unused part of his mother's body.
                            Her tender, virginal ass.
                            The first time he pushes into her, she [b]screams[/b] loud enough for the entire hamlet to hear.
                            It's a miracle none of the neighbours come to see if someone's in need of help.
                            At least she can't get pregnant if he puts it in her butt.
                            Although the few times you witnessed them going at it,
                            he pulls out just before reaching his end, finishing in her cunt instead.
                            Like he [b]wants[/b] her to have his child.
                        [/p]
                        [p]
                            Near the end of the eleventh month, the inevitable happens.
                            Juliet is pregnant.
                            The fears the baby is Falco's, and not Romeo's.
                            They both decide to keep it a secret.                            
                        [/p]
                        [p]
                            Instead of letting up on her,
                            the bird seems to get more [b]aggressive[/b] and [b]wild[/b] now that his mom has been inseminated by his seed.
                            He spanks her, pulls her hair, slaps her around and forces her to [b]choke[/b] on his cock.
                            When they're not busy [b]fucking[/b], he makes her [b]worship[/b] him around the house.
                            She serves him food, gets made to massage, clean and even [b]lick[/b] his foot-talons,
                            and come the twelfth month, her idly suckling his feathery balls while he relaxes in the couch,
                            the both of them fully nude most of the time, has become the new norm of things.
                        [/p]`;

        toReturn += `   [p]
                            [todo]To be continued.[/todo]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled} disabled>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusive.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidAbusiveLeave(ctrl);
    var secondNext = new FarmerMaidAbusiveWatch(ctrl);
    var thirdNext = ctrl.fragments.handjob;

    var firstChoice = ctrl.parentsChoice.LEAVE;
    var secondChoice = ctrl.parentsChoice.WATCH;
    var thirdChoice = ctrl.parentsChoice.HANDJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            About two and a half months into your forced servitude, you are awoken by loud arguing coming from the dining room.
                            Sleepily getting up to see what the trouble is all about, you find the farmer having a heated discussion with his wife,
                            while Falco sits and watches from across the table, a smug smirk plastered across his face as he slowly eats his breakfast-sandwich.
                            It seems you've arrived quite late,
                            the [i]argument[/i] rapidly escalating.
                            Curiosity getting the best of you, you listen in.
                        [/p]
                        [p]
                            "[color=ppink]I'm not seeing anyone, I swear![/color]"
                            pleads Juliet.
                            Her husband is having none of that, however.
                            "[color=red]I may be a simple farmer, but I'm not [b]stupid[/b]!
                            I [b]know[/b] what those stains on the back of your pants are from!
                            Now [b]tell me[/b] who it is, so I can [b]stab[/b] my rake through his heart![/color]"
                        [/p]
                        [p]
                            Oh dear.
                            It sounds like he's found a few hints of what his wife and son have been up to in his absence,
                            although he can't quite pin down the culprit yet.
                            You [i]sort of[/i] want to come clean, but you fear the man might misplace his rage, and turn on [b]you[/b] instead.
                            Plus, if the woman doesn't back you up, it'd be your word against Falco's.
                            And that's not an argument you think you'd win.
                        [/p]
                        [p]
                            "[color=ppink]It's [b]butter[/b]-stains![/color]"
                            His rage boiling over, the farmer harshly [b]slaps[/b] his wife, hard enough to [b]knock[/b] her to the floor.
                            She bursts out into tears, lying on her back while her husband looms over her.
                            Well, now you know where the eagle got his manners from.
                            "[color=red]I'll catch you one of these days,
                            and when I do, I'll kill you and your lover [b]both[/b]![/color]"
                            That said, he storms out of the back door, loudly [b]slamming[/b] it shut behind him.
                        [/p]
                        [p]
                            Juliet remains on the ground, crying her eyeballs out.
                            She clearly doesn't know [b]what[/b] to do anymore.
                            Her son rises from his seat, leaving his half-eaten breakfast on the plate.
                            He casually approaches the downed housewife.
                            For a moment, you think he might [i]help her up[/i], but he doesn't.
                            Instead, he steps over the woman, and then kneels down over her,
                            pinning the woman down by sitting ontop of her.
                        [/p]
                        [p]
                            Wasting no time and no words,
                            Falco yanks down his mother's top,
                            exposing her bountiful bosom.
                            Then, he begins to fiddle with his belt.
                            You've seen them mess around enough to know where this is going.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`Still not your business. Leave the room and pretend this never happened.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Watch</button>`;

        var tooltip = global.parser.parse(`Stay while the boy has his way with his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled} disabled>Jerk him off</button>`;

        var tooltip = global.parser.parse(`Offer a handjob to sate the kid instead. He wanted you initially, right? [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusive.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidPreAbusive.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Over the course of the later half of your first month,
                            you continue to stumble upon Falco and Juliet,
                            the bird's [i]hormonal outbursts[/i] growing more severe as time progresses.
                        [/p]
                        [p]
                            A few days after you first encountered them,
                            you find the avian and his mother in the dining room.
                            He's rubbing her bare tits from behind, to his heart's content,
                            while she's trying to eat her meagre lunch, hoping that by [b]ignoring[/b] him, he'll get bored and go away.
                            Bad idea.
                            While you don't stick around to watch, they stay inside of that room for an entire hour,
                            until finally the eagle emerges, a thoroughly sated look on his face.
                        [/p]
                        [p]
                            A week after, while you're busy cleaning the living room,
                            Falco walks in and takes a seat right next to his mother on the couch.
                            He repeatedly places his feathery hand upon her thigh, but she slaps it away time after time again.
                            He doesn't relent, however.
                            After a dozen tries, Juliet reluctantly ceases her efforts to stop him, a defeated sigh denoting her unwillingness.
                            Her son eagerly presses his palm in between her legs,
                            and begins to [b]rub[/b] her loins through her pants right in front of you.
                            Disgusted, you leave the room.
                        [/p]
                        [p]
                            You sleep with a troubled conscience, but at least you're glad [b]you[/b] aren't the one being molested.
                            Things get even worse at the start of your second month.
                            You catch the two on Romeo's bed,
                            the avian ontop of the human,
                            pinning her to the mattress while eagerly kissing her,
                            not an easy feat considering his beak.
                            Oh well, at least that's one room less for you to clean today.
                        [/p]
                        [p]
                            You rarely see the man of the house.
                            He often leaves to work his field long before you get up, and he comes home late, after everyone's already gone to sleep.
                            He must not get a lot of sleep.
                            No wonder his son is running rampant, without a stern father figure around in his life.
                        [/p]
                        [p]
                            Another week later, you find them in the kitchen, where it all began.
                            Juliet is leaning against the counter,
                            her tits bared and her pants pulled down to her knees, her hairy cunt fully exposed.
                            She embarrassedly stares off the the side,
                            while her son leers at her half-naked frame,
                            wildly jerking his uncut, humanoid member.
                            Huh, so he has a [b]human[/b] dick?
                            That's not what you [i]pictured[/i] him with.
                            Must be because he's a crossbreed or something.
                            As the bird shoots you a lewd, suggestive wink,
                            you walk away, fearing he might go after you next.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidPreAbusive.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentHandjob.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentHandjob(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.HANDJOB;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.absentDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            (Reluctantly) Jerk the boy off.
                            Check ctrl.maid's choice if you need to know whether this was following mom's pushdown or not.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentHandjob.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGirlfriend(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Single blowjob/handjob turns into daily blowjobs/handjobs.
                            Kid keeps pushing for more, but you keep denying him.
                            Eventually, he grows bored and the blowjobs stop.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentBlowjob.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentBlowjob(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.BLOWJOB;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.absentDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            (Reluctantly) Suck the boy off.
                            Check ctrl.maid's choice if you need to know whether this was following the fuck request or to sate him.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentBlowjob.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsent.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = ctrl.fragments.handjob;
    var secondNext = ctrl.fragments.blowjob;

    var firstChoice = ctrl.parentsChoice.HANDJOB;
    var secondChoice = ctrl.parentsChoice.BLOWJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the sixth week, the routine is broken.
                            Falco storms into the dining room, clearly upset about something.
                            Romeo and Juliet are nowhere to be found, as usual.
                            That leaves only [b]you[/b] to vent his frustration on.
                            And he [b]isn't[/b] looking to talk.
                        [/p]
                        [p]
                            The eagle forcibly [b]bends[/b] you over one of the dining table chairs.
                            He lifts your tail, and brings the flat of his palm to bear upon your sensitive butt,
                            harshly [b]spanking[/b] your ass with all of his might.
                            He crudely [b]smacks[/b] your reddening rear again and again and again.
                            You cry out in pain, and [b]beg[/b] for him to stop, every blow stinging more than the last.
                            But he isn't listening.
                            He's intent on discharging every last bit of his hormonal annoyance and anger,
                            even if that means [b]paddling[/b] your behind until you can barely even [b]walk[/b] anymore.
                        [/p]
                        [p]
                            While not as bad as the torture you went through at the start of your enslavement,
                            the following ten minutes still [b]hellish[/b] beyond belief.
                            Your sore hindquarters get struck over and over,
                            your begging pleas and agonized shouts echoing throughout the empty house.
                        [/p]
                        [p]
                            Only after your tears have long run out, does the torment come to an end.
                            But Falco isn't done with you yet.
                            He yanks you off the chair, and onto your knees.
                            Unbuckling and dropping his pants, he presents you his rock-hard member, the tip all but rubbing in your face.
                            "[color=yellow][b]Suck it, slave.[/b][/color]" he states, giving his length a few much-needed strokes.
                            "[color=yellow]Or I'll [b]tear[/b] your outfit and go tell my dad you tried to escape.[/color]"
                        [/p]`;
        
        toReturn += `   [p]
                            [todo]To be continued.[/todo]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled} disabled>A handjob</button>`;

        var tooltip = global.parser.parse(`You don't have a choice. Use your hands to pleasure the bird. Hope that'll sate him. [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} disabled>A blowjob</button>`;

        var tooltip = global.parser.parse(`Suck him off to please the avian. [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You give him:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsent.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidPreAbsent.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAbsent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAbsent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            You sleep with troubled dreams that night,
                            the memory of being molested repeating itself over and over in your mind,
                            manifesting itself as horrible nightmares.
                            You wake up late in the morning, feeling more sleepy than when you went to bed.
                            Time for the daily routine to pick up once more.
                        [/p]
                        [p]
                            You go about your day, doing your duties as a maid.
                            You clean the den, you wipe the tableware after breakfast, you tidy rooms,
                            and you end with sweeping the floor in the kitchen.
                            You take a small break, gazing out the window, admiring the outside world.
                            You get lost in your own thoughts, wearily daydreaming, half falling-asleep.
                            So distraught are you, that you don't even notice Falco sneaking up behind you.
                        [/p]
                        [p]
                            You [b]yelp[/b] in surprise as the avian suddenly [b]grabs[/b] your bare bottom,
                            rubbing and squeezing your naked ass to his heart's content, kneading your scales and cupping your buttcheeks.
                            Before you even properly realize what's going on, the boy has already left.
                            You hear him climbing the stairs, and locking himself in his room once again.
                            Hoping this won't be a repeating occurrence, you head to bed.
                        [/p]
                        [p]
                            More nightmares.
                            You drift awake multiple times during the night.
                            Come time to wake up, it feels like you barely slept at all.
                            And again, throughout the day, Romeo's son sneaks up behind you to cop a feel of your supple kobold body.
                            This time, he tugs down your maid outfit, baring your tits before crudely [b]squeezing[/b] your nipples.
                            You're too tired to resist.
                            Lousy little pervert.
                        [/p]
                        [p]
                            Every single day of the remaining half of the first month of your stay,
                            Falco cops a feel of your body.
                            There is no rhyme or reason to his actions.
                            Sometimes he grabs your tits in the morning,
                            on a few occassions he molests you right after lunch,
                            other times he gropes your butt right before you head to bed.
                            Once or twice, when a day seemingly goes by without molestation,
                            he even finds his way to your basket during the night, to touch you while you sleep.
                        [/p]
                        [p]
                            Even the fondling itself is inconsistent.
                            Often, he restricts himself to only a few light squeezes or pinches,
                            but there are encounters where you find yourself pressed against a cabinet for the better half of an hour,
                            while he runs his grubby little hands all over your scales, from the bottom of your behind to the back of your neck.
                            There are only two things you can count on when dealing with the bird.
                            The first is that not a day goes by without his unwanted attention.
                            The second is that once he's done with you,
                            he rushes upstairs and locks himself in his room.
                        [/p]
                        [p]
                            All of this changes around the start of the second month.
                            The avian grows more bold.
                            Your [i]sessions[/i] together grow longer.
                            His hands find their way in between your thighs on more than one occassion,
                            teasingly at first,
                            but all too soon he starts outright [b]rubbing[/b] your slit.
                            You continue not paying him any attention,
                            simply letting him [i]experiment[/i] with your body to avoid having to face his father.
                        [/p]
                        [p]
                            Near the end of the fifth week of your stay,
                            Falco outright [b]fingering[/b] your ${virgin ? `virginal` : ``} cunt has become a daily event.
                            While he doesn't [i]turn you on[/i] in the slightest,
                            your body is starting to respond to the attention it's receiving.
                            A single touch leaves you unfazed,
                            but after an entire hour of groping, prodding, fingering and teasing,
                            you sometimes find your folds growing slightly [i]moist[/i] and [b]damp[/b] by the time he's done with you.
                        [/p]
                        [p]
                            Being left flustered is the least of your concerns.
                            The bird's daily, lengthy molestation is eating away at the time you spend cleaning.
                            Luckily, his parents are too busy to notice that you've been [i]slacking off[/i].
                            His mother makes frequent trips to Varanar, and his father is off working the fields day-in, day-out.
                            You wish you had the heart to tell the boy off,
                            but every time you see Romeo, you are reminded of why you put up with his son's behavior.
                            The large human has worked up quite the temper.
                            You think the farming business isn't going so well.
                        [/p]
                        [p]
                            Near the start of the second week of the second month,
                            things deteriorate further.
                            While vigorously squeezing your rear as usual,
                            Falco's motions suddenly grind to a halt.
                            A pensive look is plastered across his face.
                            Like he's had a realization.
                            An epiphany.
                        [/p]
                        [p]
                            The avian fiddles with his belt,
                            unbuckling the leather strap, letting his pants fall to the floor,
                            his fully erect, uncut humanoid member springing free, mere inches away from your rear.
                            For a moment, you fear he's about to [b]rape[/b] you, but instead,
                            he simply gives his shaft a few rapid pumps with his hand,
                            before squirting a hefty load of pungent bird spunk over your bubbly butt.
                        [/p]
                        [p]
                            Shocked, you do nothing but look back at him in horror,
                            while he paints your ass white with the contents of his feathery, low-hanging balls.
                            His orgasm over, he pulls up his pants once more, rebuckles, and wanders off to continue his day,
                            leaving you to deal with the mess he made.
                        [/p]
                        [p]
                            That week, him masturbating while toying with your body becomes commonplace.
                            He always finished on your scales,
                            be it by coating your breasts,
                            lifting your tail and blowing his load on the base,
                            or simply finishing on your shapely behind.
                            You have to remind him several times [b]not[/b] to stain your maid outfit.
                            He begrudgingly listens to your advice,
                            neither of you keen on having his parents find out about this entire or deal,
                            each for your own reasons.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidPreAbsent.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidResist.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidResist(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.RESIST;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            You sternly [b]slap[/b] the boy's hands off of your chest.
                            Turning around, you push him away from you.
                            "[color=yellow]Hey!
                            You're my [b]slave[/b].
                            You can't push me away like that!
                            Want me to go tell my dad you're being [b]rude[/b] to me?[/color]"
                        [/p]
                        [p]
                            You kindly inform the avian that you are [b]not[/b] his slave.
                            You are his [b]father[/b]'s slave, and his [b]maid[/b].
                            You clearly remember the human saying, on the day you were bought, that you are [b]not[/b] a pet.
                            His ogling, you permitted, because it didn't really bother you too much, but this time, he took things too far.
                            If anything, [b]you[/b] should be the one telling Romeo about what happened here.
                        [/p]
                        [p]
                            While you are still not used to talking without teeth, you think you got the point across.
                            Your words clearly upset the avian.
                            He glares at you with an intense hatred in his beady eyes.
                            For a moment, he raises his hand, as though he's about to strike you,
                            yet he manages to refrain.
                            Instead of knocking some sense into you,
                            the bird angrily storms out of the door.
                            That is the last you see of him that day.
                        [/p]
                        [p]
                            The day after, Falco is no longer around to ogle you.
                            In fact, you never witnessed him emerging from the dining room after breakfast.
                            He must have left through the back door.
                            After finishing your duties in the den,
                            you swing open the kitchen door,
                            and stumble upon something you wish you hadn't seen.
                        [/p]
                        [p]
                            The eagle is bending his human mother over the countertop,
                            one of his hands wantonly groping her shirt-covered chest,
                            while he grinds his bulging member against her shapely behind.
                            He doesn't even stop when he notices you,
                            instead shooting a wicked smile your way,
                            pinching Juliet's nipple to make her [b]squeal[/b].
                        [/p]
                        [p]
                            For a moment, you look on in shock,
                            your brain refusing to believe what your eyes are seeing.
                            The boy gives his mother an explicit [b]hump[/b],
                            rubbing his groin against hers,
                            rocking her body back and forth along the countertop.
                            Unsure of how to react, you are frozen in place for a few seconds more.
                            Then, you awkwardly back away,
                            and close the kitchen door like you were never even there,
                            leaving the two to their privacy.
                        [/p]
                        [p]
                            Your heart is racing.
                            Falco molesting his mother?!
                            You wonder if he's doing this because you denied him,
                            or if this was an ongoing thing that you only just now stumbled upon?
                            She didn't seem too happy about it,
                            but she wasn't resisting his grasp either.
                            She could have easily thrown him off if she wanted to.
                        [/p]
                        [p]
                            You briefly wonder whether or not you should [i]intervene[/i],
                            or perhaps tell Romeo about what's happening,
                            but you'd rather not poke that hornet's nest.
                            This is between Juliet and her son.
                            A familial affair.
                            It would be rude of you to butt in.
                            You're a slave, not a relationship counselor.
                            It's none of your business.
                            So you act like you saw nothing.
                            Like everything is [b]fine[/b].
                            Ignoring the events unfolding in the kitchen, you head upstairs and clean the family's rooms.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidResist.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidEncourage.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidEncourage(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ENCOURAGE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAmorous(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            So, the boy is [i]interested[/i] in your body, huh?
                            Scolding him for being curious would be awfully rude of you,
                            not to mention kind of [i]hypocritical[/i].
                            Instead, you decide to give him a little [i]show[/i].
                            Something he will [b]never[/b] forget.
                        [/p]
                        [p]
                            You turn around, the avian removing his hands from your bosom, clearly thinking you're about to tell him off.
                            His face turns to shock, when instead of angrily reprimanding him,
                            you promptly tug down your maid dress, showing your naked tits to the eagle.
                            His eyes go wider still, as you take his hand, and place it upon your bare breast-scales,
                            giving him a reaffirming nod in the process.
                        [/p]
                        [p]
                            Falco eagerly rubs and squeezes your chest, his second hand joining in on the fun.
                            His inexperience is kind of [i]endearing[/i].
                            You only barely manage to suppress your excitement, as he [b]squeezes[/b] one of your nipples.
                            It's like he's never seen a pair of breasts before in his life.
                            Juliet must not have wanted to breastfeed him.
                            You don't blame her -- he [b]does[/b] have a beak, after all.
                        [/p]
                        [p]
                            Speak of the devil, both you and your new avian friend gasp in surprise,
                            as your notice the front door being fiddled with.
                            You instantly fix your dress, and return to cleaning.
                            The bird, panicking, flees up the stairs.
                            Through the front door walks his mother,
                            home from shopping for foodstuffs in Varanar.
                        [/p]
                        [p]
                            She greets you, and with a flushed look on your face, you welcome her home.
                            She suspiciously stares at you for a few tense moments.
                            Shrugging, the woman asks you to help her carry the goods she brought him to the kitchen.
                            And so, your life as a maid resumes.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidEncourage.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidAbide.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbide(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ABIDE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbsent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You don't like this.
                            Getting fondled by a bird of questionable age,
                            while dressed up as a skimpy maid,
                            cleaning the house of the farmer that bought you.
                            But you can't stop him.
                            He's the [b]son[/b] of your master.
                            If you don't give him what he wants, he'll cry to his dad.
                            And who knows what Romeo might do to you then?
                            Torture you more?
                            [b]Kill[/b] you?
                        [/p]
                        [p]
                            You can't take that risk.
                            Even if that means getting fondled against your will.
                            You just have to let the avian sate his curiosity.
                            You're certain he'll back off after he's had a good feel or two.
                        [/p]
                        [p]
                            And a good feel he gets.
                            Falco wantonly squeezes your sensitive breasts with his feathery hands,
                            caressing your bosom through the thin, black fabric of your maid attire.
                            He slowly rolls his hips back and forth,
                            grinding his clothed package against your rear,
                            pleasuring his cock by squeezing it between your scaly butt and his thighs.
                        [/p]
                        [p]
                            For a moment, you think the boy is about to [b]rape[/b] you,
                            but then, as quickly as the unwanted fondling began,
                            it ends once more.
                            Suddenly, the bird lets go of you,
                            and before you can even ask him why the [b]hell[/b] he did that,
                            he [b]bolts[/b] up the stairs.
                            You can hear the door to his room opening, closing, and then locking.
                            You've a pretty good idea what he's doing in there.
                        [/p]
                        [p]
                            Anyway, you're glad it's over.
                            You [i]could[/i] go knock on his door and [b]demand[/b] an explanation,
                            but what's the point?
                            He got what he wanted,
                            and you get to live another day [b]without[/b] having your brains caved in for misbehaving.
                            You forget about the entire ordeal,
                            and continue with your day like nothing happened.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidAbide.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaid.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidMaid(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preMaid;
    var subController = ctrl.maid;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidResist(ctrl);
    var secondNext = new FarmerMaidAbide(ctrl);
    var thirdNext = new FarmerMaidEncourage(ctrl);

    var firstChoice = FarmerMaidMaidChoice.RESIST;
    var secondChoice = FarmerMaidMaidChoice.ABIDE;
    var thirdChoice = FarmerMaidMaidChoice.ENCOURAGE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The next morning,
                            you are awakened by the crowing of a rooster.
                            A feather duster and a broom lie on the floor, next to your basket.
                            Nobody's around but you.
                            You rise to your shaky, mangled feet.
                            Standing upright hurts, and you can [b]barely[/b] walk.
                            You consider fleeing, but you wouldn't get far like this.
                            Especially not with every villager in the hamlet keeping an eye out for you.
                        [/p]
                        [p]
                            That leaves three options.
                            You can make a mess of things, which will piss off your [i]master[/i] to the point where he'll probably [b]kill[/b] you.
                            While death seemed like a good alternative while you were being [i]tortured[/i],
                            right now you'd rather stay alive to see your wounds heal.
                            Alternatively, you could [b]refuse[/b] to work,
                            but given the hell you've been through already,
                            you're kind of [i]scared[/i] to think of what the human might do to you if you fail to live up to his expectations.
                            You can't take much more abuse.
                        [/p]
                        [p]
                            So, that leaves option number three: you clean.
                            As long as you do what your master expects of you,
                            he'll have no reason to [i]hurt[/i] you.
                            And you kind of [b]want[/b] that morsel of food he alluded to.
                            With that, your mind is made up.
                        [/p]
                        [p]
                            Bending down, you pick the broom up off the ground.
                            Gripping things with your fucked up fingers is painful,
                            but you manage to get a loose hold on the handle.
                            Swallowing what little of your pride you have left,
                            you deftly begin to sweep the wooden floor clean of dust, dirt and filth.
                            Due to your injuries, you can't really do a very good job,
                            but you try your best.
                        [/p]
                        [p]
                            Come dinner time, your dilligent efforts are rewarded.
                            You get a small piece of moldy old bread.
                            While your lack of teeth prevents you from [i]chewing[/i],
                            you let the stale, hard crust soak in your mouth,
                            until it disintegrates into pieces,
                            so you can swallow it down more easily.
                            While not much, it's [b]a lot[/b] better than nothing.
                        [/p]
                        [p]
                            The second day goes a lot like the first.
                            Your wounds are healing, your cleaning-technique steadily improving.
                            Growing accustomed to not having teeth, your speech also betters.
                            Another piece of moldy bread keeps you going.
                            The farmer's wife and son mostly ignore you.
                            You pick up their names by eavesdropping when they talk to one another.
                            Juliet and Falco.
                            Weird name for an eagle.
                            You don't dare bring it up, out of fear he'll take offence.
                        [/p]
                        [p]
                            Over the course of the week,
                            you listen in to multiple conversations,
                            trying to understand the [i]family dynamic[/i] between the bird and his [i]parents[/i].
                            From what you gather, Romeo and Juliet got together,
                            one day a bird came to visit,
                            and some time later Falco was born.
                            You don't know how a human gave birth to a bird,
                            but apparently that's what happened.
                            You wonder whether she laid an egg, or if it was a live birth.
                            Maybe he was [i]adopted[/i]?
                        [/p]
                        [p]
                            Near the end of your first week of proper [i]captivity[/i],
                            you notice the farmer's son starting to take an interest in you.
                            He begins to lounge around the house a lot more,
                            staring at you while you work.
                            At first, he tries to hide his curiosity from you,
                            looking away when you return his gaze.
                            As the days go by, he grows more bold.
                            He keeps his eyes fixed on you, sometimes for hours at a time.
                            At the start of the second week, you catch him outright [b]ogling[/b] you,
                            his eyes fixed on your exposed butt.
                        [/p]
                        [p]
                            The lecherous leering gradually becomes more and more commonplace.
                            Especially when you bend over to pick something up, the boy's eyes are trained on your backside.
                            Then, near the end of the second week, while cleaning one of the cabinets in the living room, the situation escalates.
                        [/p]
                        [p]
                            The avian rises from his seat on the couch,
                            and walks up right behind you,
                            his clothing-clad groin pressing into your bubbly rear.
                            You can feel his stiff member prodding against your butt through his pants.
                            Without a word, his hands roam to your chest, and he casually begins to molest your barely covered breasts,
                            his breath audibly growing heavier.
                            You don't know how old he is, but you doubt this is appropriate behavior for his age!
                            How do you react?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Resist</button>`;

        var tooltip = global.parser.parse(`Be firm, and tell the boy to stop.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Abide</button>`;

        var tooltip = global.parser.parse(`Let him have his fun. He'll grow tired of touching you soon enough.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 240px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Encourage</button>`;

        var tooltip = global.parser.parse(`Teach the kid a thing or two.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidMaidChoice = {
    RESIST: 1,
    ABIDE: 2,
    ENCOURAGE: 3
};

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaid.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidRecover.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidRecover(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.recover;
    var subController = ctrl.preMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidMaid(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.dick();
        var recap = ctrl.gender.get() === FarmerMaidGenderChoice.BLACKOUT;
        var toReturn = `[p]
                            Some time later, you wake up from a deep, troubled period of unconsciousness.
                            You don't know how long you were out.
                            Minutes?
                            Hours?
                            Days?
                            For a moment,
                            you entertain yourself with the idea that the faint memories of you enduring excruciating torture were nigh but [b]dreams[/b].
                            Delirious nightmares.
                            Fantasies, and nothing more.
                            As your senses slowly drift awake,
                            you become aware once more of the [b]crippling[/b] pain coming from your mouth, your hands and your feet.
                            The illusion is quickly shattered.
                            It really [b]did[/b] happen.
                        [/p]
             ${recap ? `[p]
                            Your head hurts.
                            Your [b]everything[/b] hurts.
                            Your teeth have been removed, pulled out one at a time.
                            Your claws suffered the same fate, your fingers and toes half-[b]mutilated[/b] as a result.
                            To make matters worse, your ass has been branded,
                            the insignia scorched on your scales marking your status as a [b]slave[/b].
                        [/p]` : ``}
                        [p]
                            You painstakingly open your heavy eyelids, to find yourself indoors.
                            You are lying curled up inside of a large and rather comfortable basket.
                            Several clumps of fur make you think this used to belong to a feral dog.
                            You wonder if it got its claws and teeth removed as well.
                            You hope it didn't.
                        [/p]
                        [p]
                            The more awake you get, the more your body aches.
                            You groggily come to an upright, seated position.
                            Your hands and feet look [b]terrible[/b].
                            The bleeding has stopped, but your fingers continually twitch like you're some old [i]witch[/i] casting a [b]curse[/b].
                            Your nerves must have gotten seriously damaged.
                        [/p]
                        [p]
                            You keep on trying to rest your teeth atop one another,
                            but the simple fact is that you [b]have none[/b].
                            As a result, you squish your sensitive,
                            hurting gums against one another time after time again,
                            making you wince in pain over and over.
                        [/p]
                        [p]
                            While your senses slowly grow accustomed to being bombarded with constant pain,
                            you look around the room you're in.
                            It looks like a living room,
                            four shabby, half-rotten wooden walls interrupted only by a trio of doors.
                            One to the kitchen, one which you think [i]might[/i] lead outside,
                            and a third to a stairwell.
                        [/p]
                        [p]
                            A big bench-resembling couch with little padding dominates the room.
                            The basket you're in -- which you presume will be your resting spot for the remainder of your stay here -- is next to the couch.
                            Various aging cabinets and cupboards are lined along the delapidated walls.
                            Not a single piece of art in sight,
                            apart from a small, plain, cheap vase holding a few backyard flowers atop a piece of wooden furniture.
                        [/p]
                        [p]
                            While [b]massive[/b] compared to your shack in the woods,
                            you understand that this is a [i]poor[/i] home, as far as human households go.
                            Then again, besides Seki's workshop and the [i]mansion[/i] across the road from it,
                            [b]every[/b] home in the hamlet is [i]impoverished[/i].
                            You wonder how the farmer was able to [i]afford[/i] you, but you're certain you wouldn't like the answer even if you knew.
                        [/p]
                        [p]
                            Suddenly, movement.
                            Romeo, the man of the house, walks in through the front door.
                            Glistening sweat rolls down his brow.
                            He must be getting home from working the fields or something.
                            His attention immediately turns towards you, his mere gaze inspiring fear.
                            You curl up into a ball once more, clutching your tail, trembling in fear.
                            "[color=red]Finally awake?
                            I was starting to think you'd slip into a coma.[/color]"
                            A coma?!
                            How long were you out for?
                        [/p]
                        [p]
                            The man moves towards one of the cupboards.
                            Opening it, he reaches in and pulls out a maid outfit, suitable for a child, or a kobold like yourself.
                            Did he get that just for you, or is that something his [i]son[/i] used to wear?
                            He tosses the garment towards you.
                            On closer inspection, it's kind of [i]skimpy[/i].
                            You don't think this will cover your butt [b]at all[/b], and it'll [b]barely[/b] conceal your loins!
                        [/p]
                        [p]
                            You try to voice your objections, but speaking without teeth proves to be quite a bit harder than you'd thought.
                            You don't manage to form any coherent words, apart from some rabid mumbling.
                            Realizing you aren't getting your point across, you end with a reluct, teary sigh.
                            "[color=red]Why I bought you?[/color]"
                            No, that's not what you were asking at all, but there's no point trying to correct him.
                            "[color=red]To clean my house, and to shut my son up about wanting a new pet.[/color]"
                        [/p]
                        [p]
                            A [i]pet[/i]?
                            Great.
                            Just what you needed, to be treated like an [b]animal[/b].
                            You give the human a sour, sulking look.
                            "[color=red]Don't even [b]think[/b] about running away.
                            Every man in town knows you're [b]mine[/b].
                            One look at your ass, and they'll know to capture or kill you.
                            If you're lucky, that is.
                            They might want to keep you for themselves,
                            and I can assure you that I am [b]far[/b] from the worst person in this village.[/color]"
                        [/p]
                        [p]
                            Wow, this guy really knows how to lift your spirits, huh?
                            Then again, these farmers [b]aren't[/b] known for being the most [i]charismatic[/i] fellows.
                            "[color=red]As long as you do what you're told, you'll be treated fairly,
                            and we'll even toss some food your way every now and again.[/color]"
                            Well, at least you won't [i]starve[/i].
                            "[color=red]Oh, and while I've already taken away most of your [i]dangerous[/i] bits,
                            you lay even one hand on my wife or my son, and I will make you [b]wish[/b] you were never born.[/color]"
                            He already has.
                        [/p]
              ${male ? `[p]
                            So, you [i]kind of[/i] understand why he took out your claws and your teeth.
                            You don't [b]agree[/b] with him doing those things, but you understand [b]why[/b] he did them.
                            But one thing that you can not wrap your head around is why exactly he turned you into a [b]girl[/b].
                            Unable to properly speak, you give the human a quizzical, upset look through your teary eyes, whilst pointing towards your groin.
                        [/p]
                        [p]
                            "[color=red]Oh right.
                            My cousin in law told me that [i]male[/i] kobolds tend to get [b]territorial[/b] during mating season.
                            I could have [b]neutered[/b] you instead,
                            but I figured the bloodloss from cutting out your balls might have [b]killed[/b] you.
                            You should [b]thank me[/b], really.[/color]"
                            [i]Territorial[/i]?
                            [b]Mating season[/b]?!
                            You don't know what [b]animal[/b] he's talking about,
                            but the human is grossly misinformed on your kind.
                        [/p]
                        [p]
                            But it's too late to complain.
                            The damage is already done.
                            And even [i]if[/i] you could talk properly,
                            you doubt your voice of reason would be heeded.
                            "[color=red]Besides, have you ever heard of a [b]male[/b] maid?
                            I sure haven't.
                            People might start getting the [i]wrong idea[/i] about me or my kid.
                            Not that I plan on fucking you.
                            I have my wife for that.
                            You're a [b]maid[/b].
                            Not a [b]whore[/b].[/color]"
                            While slightly reassuring, this is getting pretty awkward.
                        [/p]` : ``}
                        [p]
                            "[color=red]Your maid duty starts tomorrow.
                            Get some more rest.
                            You look like you could use it.[/color]"
                            No arguing there.
                            You think you could sleep for an entire [b]month[/b] and [b]still[/b] feel like [b]shit[/b].
                            The man gives you an assertive nod,
                            then walks out of the room.
                        [/p]
                        [p]
                            After wiping your tears on the child-sized maid dress,
                            you reluctantly put it on.
                            While not freezing cold, this house isn't very [i]warm[/i], either.
                            You hope the thin fabric will keep you at least [i]somewhat[/i] heated.
                            At least it'll be warmer than sleeping in the nude.
                            You curl up into a ball once more,
                            cuddling up against the edges of the basket you're in,
                            and cry yourself to sleep.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        console.log("here");
        
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("hamlet_barn");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidRecover.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidBrandmark.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidBrandmark(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.teeth;
    var subController = ctrl.recover;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.recover;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            The men still aren't letting go.
                            You are bent over forwards.
                            Your tail is yanked up.
                            Are they going to [b]rape[/b] you?!
                            After all of this?
                        [/p]
                        [p]
                            After wiping them clean, Romeo puts his tongs back where they belong.
                            Stepping over to the kiln next to the shed,
                            he pulls out one of the sizzling irons, tipped with a blazing-hot insignia.
                            As the human steps behind you, the other men reinforce their grip on you.
                            Like they know you're about to [b]struggle[/b].
                        [/p]
                        [p]
                            And struggle you do.
                            Your owner mercilessly [b]rams[/b] the blazing brand against your right buttcheek,
                            a simmering sound muffled by your panicky screams, your scales [b]searing[/b], even the flesh underneath [b]burning[/b].
                            You wriggle your body around as best you can, trying but failing to get away from the scorching pain.
                            "[color=red]Keep'er [b]steady[/b]!
                            The pain might [b]kill[/b]'em if I have to do this twice.[/color]"
                        [/p]
                        [p]
                            He holds it in place for what seems like an [b]eternity[/b].
                            There is no escape.
                            Your eyes roll into the back of your head.
                            Your entire body goes limp.
                            You finally pass out.
                            Death or unconsciousness, you welcome them both.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidBrandmark.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidTeeth.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTeeth(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.claws;
    var subController = ctrl.teeth;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidBrandmark(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While the searing pain still inhibits much rational thought,
                            your nerves calm a very little, believing your torment to be over.
                            Nothing could be further from the truth.
                            As your breathing starts to stabilize, you notice the men haven't [i]let go[/i] of you yet.
                            Are they [i]not[/i] finished yet?
                        [/p]
                        [p]
                            A pair of filthy hands finds its way inside of your gaping maw,
                            and spreads your jaws open wide.
                            You are far too worn out to resist.
                            Romeo shallowly presses one of his fingers into your muzzle,
                            rubbing the tips of the bottom row of your sharp teeth.
                            Giving a reaffirming nod to his [i]friends[/i], he ominously nears your mouth with the pliers.
                        [/p]
                        [p]
                            Realizing what is about to happen, you struggle as hard as you can, but your drug-weakened,
                            weary body is no match for the multitude of strong farmers holding you in place.
                            Even your jaws, otherwise extremely powerful,
                            with teeth capable of biting even through thin metal,
                            are easily overpowered by a single set of hairy, grimy fingers.
                            You are completely powerless to stop them,
                            and that fact hurts you far more than their torture ever could.
                            Or so you hope.
                        [/p]
                        [p]
                            Your owner clamps one of your sharp fangs in between the jaws of his pliers.
                            You audibly weep, shivering from pain, shock and trauma.
                            But he doesn't care.
                            Your claws were dangerous.
                            So are your teeth.
                            He can't let a [b]wild animal[/b] into his house without [i]disarming[/i] it first.
                            For all he knows, you could tear his son's throat out, or scar his wife for life.
                            And he's not going to let that happen.
                        [/p]
                        [p]
                            Romeo tormentingly wriggles your tooth about, so hard you fear he might [b]break it off[/b].
                            But that's not his plan.
                            He's merely [b]loosening[/b] it.
                            After a few agonizing moments, he [b]pulls[/b] backwards, [b]yanking[/b] the fang straight out of your mouth,
                            tearing the very roots of your tooth from your gums.
                            You [b]scream[/b] out in pain, louder than you have ever screamed before.
                            Your mouth floods with blood, which oozes from your muzzle, diluted with spit.
                        [/p]
                        [p]
                            This is hell.
                            You fell off the stage at the auction, broke your neck and [b]died[/b].
                            These [b]demons[/b] are torturing you.
                            Your head is tilted upwards, your own blood running down into your throat.
                            You have no choice but to swallow it.
                            Your second fang is taken in between the pliers.
                            At least this time he doesn't wriggle it around.
                            A single [b]tug[/b] sends a new soul-crushing wave of torment coursing throughout your body.
                            Another tooth lost.
                        [/p]
                        [p]
                            You are defanged.
                            But still they do not let go.
                            What more do they want?
                            Oh no.
                            The farmer you belong to wipes the blood off of his pliers,
                            before pressing them into your mouth once more.
                            This time, he takes hold of an incisor next to the hole where one of your fangs used to be.
                            Then you realize.
                            It's not just your fangs.
                            He wants to remove [b]all[/b] of your teeth.
                            With that thought, your mind goes blank once more, unable to cope with the situation at hand.
                        [/p]
                        [p]
                            You come to your senses halfway through your teeth-removal,
                            prodded awake by a [i]new[/i] type of pain.
                            Working on one of your back teeth, Romeo has accidentally placed his pliers too high.
                            Instead of clamping on to the molar he was aiming for, his tongs sink into your soft, sensitive gums.
                            Not realizing his mistake, he presses down hard with both of his hands,
                            [b]squeezing[/b] your flesh in between the two metal jaws hard enough to [b]draw blood[/b].
                            You let out an agonized gurgle, coughing up some of the various fluids pooling at the back of your throat.
                            Only after several seconds of [b]crushing[/b] your upper jawbone to the point of [b]shattering[/b] it,
                            does he readjust his grip, and manage to pull the tooth out in a single rip.
                        [/p]
                        [p]
                            While you, [i]sadly[/i], don't manage to have any more mini-black outs,
                            events somewhat start to blur together after your owner's [i]mishap[/i].
                            One tooth gets yanked out after the other, and before you know it, your entire mouth is empty and barren.
                            The scruffy fingers are removed from your mouth,
                            and your aching jaw can come to a rest.
                            You make the mistake of fully closing your mouth, pressing your bleeding gums against one another,
                            the sudden pain almost making you [b]choke[/b] on your own spit.
                        [/p]
                        [p]
                            As your head is let go of, you let it limply hang off your neck,
                            letting the blood seep from your muzzle onto the ground,
                            which is already running red from the liquid still spilling from your fingers and toes.
                            At least it's over.
                            It [b]is[/b] over, right?
                            There's nothing left of you to remove.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidTeeth.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidClaws.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidClaws(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGenderChoice.CLAWS;
    var reqController = ctrl.gender;
    var subController = ctrl.claws;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidTeeth(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            That sickness you felt before returns, but in a [i]different[/i] way.
                            Like you know something [b]horrible[/b] is about to happen,
                            but you are powerless to stop it.
                            You meekly struggle against the men, but they barely even [b]feel[/b] your weakened limbs attempting to move.
                            Since your arm is already extended, your [i]owner[/i] decides to start with your hand.
                            Your palm is firmly grasped, and one of your fingers is held out.
                            The human catches your claw in between the flat ends of the tongs,
                            squeezing so tightly, the metal almost digs into the keratin.
                        [/p]
                        [p]
                            He starts to pull, to tug at your talon, stretching your finger to its limits.
                            One of the other men holds the digit in place, as the farmer ups his efforts,
                            heavily tugging at your sharp claw.
                            You wince in discomfort, the very flesh surrounding your nail exerted to its very limits.
                            Then, a sudden fierce [b]yank[/b].
                            A sickening [b]rip[/b] reaches your ears.
                            Your scales tear, and your claw is ripped whole from the tip of your finger,
                            blood oozing from the strained liquid.
                        [/p]
                        [p]
                            [b]Pain[/b] clouds your hazy mind.
                            You [b]shout[/b] out in agony,
                            not even the numbing draught suffice to quell the [b]tormenting torture[/b]
                            of having one of the parts of your body physically [b]torn[/b] away from you.
                            One of the men wants to silence you, but another halts him, picking up a dirty stick from the ground,
                            and shoving it into your maw.
                            You bite down almost hard enough to [b]break[/b] the old branch, the immense pain almost too much to bear.
                            And they're not done yet.
                            They're just getting started.
                        [/p]
                        [p]
                            Your second claw comes out a bit more easily,
                            but excruciatingly painful nonetheless.
                            Tears flow liberally from your eyes, your already blurry vision distorted further,
                            making this entire thing seem like a [b]bad dream[/b] filled with mind-shattering torment.
                            You almost lose consciousness for a bit, barely even noticing the third and fourth of your claws being removed,
                            your pain-receptors overloaded and then some.
                        [/p]
                        [p]
                            The first talon of your other hand, however, hurts every bit as much as the very first one did.
                            It feels as though your very arm is being broken,
                            as the small bit of bone holding your claw in place is [b]ripped[/b] from your finger.
                            The agony is so severe, it almost makes you want to [b]vomit[/b], but your stomach holds too few contents to hurl up.
                        [/p]
                        [p]
                            Your mind goes blank.
                            You space out.
                            You don't know for how long.
                            When you come to, your hands are shaking.
                            Your claws are gone.
                            Your fingers are oozing blood.
                            Is the torture over, at last?
                        [/p]
                        [p]
                            No.
                            The men are still holding you.
                            Your [i]owner[/i] is kneeling in front of you.
                            Extra hands are placed on your leg.
                            The tongs find their way to one of your toes.
                            [i]Oh no[/i].
                            Not more.
                            Please not more.
                            You can't [b]handle[/b] any more!
                        [/p]
                        [p]
                            They seem to have gotten the technique down.
                            One of the men grasps your toe,
                            holding it steady, while Romeo [b]jerks[/b] the claw from your skin.
                            The anguish is immeasurable.
                            Every tug feels like they're [b]scraping[/b] at your very [b]soul[/b].
                            It's not just your hands and feet.
                            Your entire [b]body[/b] hurts.
                        [/p]
                        [p]
                            The next toe-claw goes less smoothly.
                            Your talon doesn't come out in one yank.
                            You soon learn that it hurts even [b]more[/b] when the claw [b]doesn't[/b] come out,
                            your scaly flesh tearing, but not [b]completely[/b], a nasty gash forming at the tip of your toe,
                            like the entire thing is about to be torn off.
                            While you can't see due to all the drugs and the tears,
                            it feels like part of your toe gets [b]ripped[/b] off during the second tug.
                        [/p]
                        [p]
                            You should have passed out already,
                            but the inhibiting potion shot into your veins keeps you awake.
                            It slightly [b]dulls[/b] the pain, to the point where it doesn't outright [b]kill[/b] you,
                            forcing you to tolerate this [b]hellish[/b] endeavour without granting you the sweet release of unconsciousness.
                            If you could still speak any coherent words, you'd be [b]begging[/b] for death right now.
                        [/p]
                        [p]
                            Another small blackout.
                            One of your eyelids is twitching.
                            Spit oozes liberally from your gaping maw.
                            The stick in your mouth has long-since cracked and been spat out.
                            You are breathing heavily.
                            You feel like you're about to [b]die[/b].
                            But they're at your final claw.
                            A little longer.
                            One more.
                        [/p]
                        [p]
                            This one doesn't come out.
                            Your owner messes up.
                            He tugs the wrong way.
                            Another loud crack.
                            You fear he might have broken your bones,
                            but there's very little pain.
                            Perhaps you're simply not feeling it.
                            Then, you realize it was your nail that cracked.
                            Surely, that will suffice, right?
                        [/p]
                        [p]
                            "[color=red]Can't have that growing back.[/color]"
                            Romeo grabs the leftover stump with his pliers,
                            and [b]slowly[/b] pulls out the remainder,
                            the fleshy sound of tendons and scales ripping [b]burning[/b] into your mind.
                            After a few moments of absolute [b]horror[/b], a small [i]snap[/i] indicates that it is finally coming to an end.
                            You have been fully declawed.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidClaws.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidGender.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGender(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.arrival;
    var subController = ctrl.gender;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = ctrl.fragments.recover;
    var secondNext = new FarmerMaidClaws(ctrl);

    var firstChoice = FarmerMaidGenderChoice.BLACKOUT;
    var secondChoice = FarmerMaidGenderChoice.CLAWS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            The men advance on you, each grabbing on to part of your body with their large, coarse hands, fully restraining you.
                            They're going to [b]rape[/b] you, aren't they?
                            You knew you should have [b]begged[/b] Fenrir to be allowed to stay with him.
                            But it's too late now.
                            This is your fate.
                            But, instead of groping you and touching your genitals like you expected,
                            the hands remain in place, simply holding you and nothing more.
                            Are they waiting for [i]approval[/i] or something?
                        [/p]
                        [p]
                            The thought of fighting against the men's grip occurs to you,
                            but it'd do more bad than good.
                            There's too many of them for you to put up any sort of real resistance.
                            Why aren't they getting this over with already?!
                            You're mentally prepared for the [b]worst[/b].
                            But this eerie [i]calm before the storm[/i] is completely [b]nerve-racking[/b].
                        [/p]
                        [p]
                            The only person not holding you, one of the horses, is rummaging around in his pockets.
                            The dreaful silence that had begotten the group is broken by your human captor.
                            "[color=red]Well? Do you have it, or not?![/color]"
                            What the hell are they talking about?
                            "[color=purple]Gimme a minute! Don't want to stab [b]myself[/b] with that stuff.[/color]"
                        [/p]
                        [p]
                            Encouraged by the human's impatience, the equine searches around his expansive pant-pockets a bit [i]less[/i] carefully.
                            After a few more moments, he retrieves a large syringe from his trousers,
                            filled with a swirling, muddy-pinkish liquid.
                            An aphrodisiac?
                            Before you can even object, your arm is forcibly stretched,
                            and the needle is brutishly [b]rammed[/b] into your flesh,
                            piercing your scales with ease.
                            You let out a pained yelp, but your muzzle is squeezed shut by one of the men before you can shout for help.
                        [/p]
                        [p]
                            The horse injects the fluid into your arm,
                            You immediately begin to feel [b]weak[/b] and [b]drowsy[/b].
                            Not enough to knock you out, but if it weren't for the restraining hands on every part of your body,
                            you doubt your own legs could support your weight.
                            Your vision grows blurry, and you grow exceedingly [b]dizzy[/b].
                            Like you're drunk beyond belief,
                            the entire world starts to twirl.
                            Not an aphrodisiac after all.
                        [/p]
              ${dick ? `[p]
                            You sense [i]something[/i] happening to your loins, but it's [b]not[/b] arousal.
                            Your slit-sheathed member feels [b]odd[/b].
                            Like it's being [b]tingled[/b] by a thousand little feathers.
                            Through your drug-induced haze, you can't quite figure out what's happening, until it's too late.
                        [/p]
                        [p]
                            Your cock shrinks, retracting into your body, vanishing entirely.
                            Your internal testicles wither away, rapidly replaced by fully-functional ovaries,
                            a freshly formed cervix connecting your cockslit-turned-cunt to your new reproductive organs.
                            Your chest tingles, a small pair of budding breasts growing atop your otherwise smooth, scaly torso.
                            As the transformation comes to an end, a small clitoris forms at the front-end of your slit
                            [b]You are now a girl[/b].
                        [/p]` : ``}
                        [p]
                            Its contents emptied into your veins, the syringe is yanked from your arm, and discarded to the side.
                            Your muzzle is let go of.
                            You pant loudly, whining like a scolded dog.
                            "[color=red]This is for your own good, slave.
                            It'll make the next part a whole lot more bearable.[/color]"
                            Your owner reaches into the shack, and pulls out a large set of metal tongs,
                            the kind used in smithing...and in torture.
                            "[color=red]Let's start by removing those [b]dangerous[/b] claws of yours.[/color]"
                        [/p]
                        [p]
                            [sneak]
                                Choose wisely.
                                Once the [i]preparation[/i] begins, it will be too late to black out still,
                                and you will be forced to live through [b]all[/b] of it, until the very end.
                            [/sneak]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Black out</button>`;

        var tooltip = global.parser.parse(`Retreat into a lower level of consciousness to avoid witnessing the [b]horrible[/b] things about to take place.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice dangeraura ${selected}" id="${secondId}" ${disabled}>Endure</button>`;

        var tooltip = global.parser.parse(`Stay awake enough to remember every single last detail of your torture. [warn]You will regret this.[/warn]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 175px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            ctrl.recover.continue();
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        if (subController.get() === FarmerMaidGenderChoice.BLACKOUT) {
            part += firstNext.build();
        }
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (subController.get() === FarmerMaidGenderChoice.BLACKOUT) {
            firstNext.registerListeners();
        }
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGenderChoice = {
    BLACKOUT: 1,
    CLAWS: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidGender.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidArrival.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidArrival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.arrival;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGender(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Tugging you by your arm, the farmer leads you towards a shack, not too far away from his home.
                            The two of you come to a halt in front of it.
                            Instead of stepping inside, the human turns around, keeping a firm hold on you to make sure you don't [i]escape[/i].
                            He seems to be waiting for someone, or [i]something[/i].
                        [/p]
                        [p]
                            You're too [i]intimidated[/i] by the farmer's solid grasp and broad posture to ask what it is you are doing here.
                            Instead, you inspect the building.
                            Through the open door, you can see various metal tools hanging from the wooden wall.
                            A well-lit kiln stands next to it, the handles of a few iron pokers sticking out.
                            This must be the [i]workshop[/i] the human was talking about.
                            Looks kind of like a miniature smithy, although you don't see any anvils around.'
                        [/p]
                        [p]
                            After more than a minute of silent waiting, a group of burly men approach from far side of the village.
                            The anthro horses from the auction are there,
                            along with several humans who look like they've working the fields for their entire lives.
                            They seem to know your new [i]owner[/i].
                            Seeing the entourage, you swallow deeply, fearing this might be a [i]sexual[/i] thing.
                            He's going to [b]sell[/b] your body to every man in town!
                        [/p]
                        [p]
                            The men heartily greet the farmer.
                            "[color=purple]Hey Romeo.[/color]"
                            Romeo?
                            Is that his name?
                            Or is he being made fun of?
                            "[color=purple]So this is the new purchase, eh?[/color]"
                            asks one of the horses, referring to you.
                            They're all going to take turns fucking you, aren't they?
                            "[color=purple]Two hundred, was it? Expensive little lizard.[/color]"
                            You feel sick.
                            Your stomach starts to churn.
                            "[color=red]Yeah, but my house'll finally be clean, for once.
                            If only my wife was less lazy, eh?[/color]"
                        [/p]
                        [p]
                            Any minute now, they're going to lower their pants,
                            whip out their dicks and fuck you until you can barely even walk anymore.
                            "[color=red]Anyway, let's get down to business, shall we?
                            I've got crops to water before dark.[/color]"
                            Oh no.
                            This is it.
                            "[color=red]Did you bring the goods?[/color]"
                            Wait, what?
                            [i]The goods[/i]?
                            "[color=purple]Yeah, yeah.
                            Hold'em still.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidArrival.js

// scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaidController.js

/**
 * Controller for the Farmer's Maid scene.
 * @param {string} sceneId The id of the scene.
 */
function FarmerMaidController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = false;
    this.nextSceneName = "SlaveAfternoonTwo";
    this.nextFolderName = "Enslavement/DayTwo";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ContinueController(id, "arrival");
    this.gender = new ChoiceController(id, "gender");
    this.claws = new ContinueController(id, "claws");
    this.teeth = new ContinueController(id, "teeth");
    this.recover = new ChoiceController(id, "recover");
    this.preMaid = new ContinueController(id, "preMaid");
    this.maid = new ChoiceController(id, "maid");
    this.postMaid = new ContinueController(id, "postMaid");
    this.preParents = new ContinueController(id, "preParents");
    this.parents = new ChoiceController(id, "parents");
    this.postParents = new ContinueController(id, "postParents");
    this.daily = new ContinueController(id, "daily");

    this.toofar = new ContinueController(id, "toofar");
    this.toofarTell = new ContinueController(id, "toofarTell");
    
    this.girlfriend = new ContinueController(id, "girlfriend");
    this.jealous = new ContinueController(id, "jealous");
    this.frame = new ContinueController(id, "frame");
    
    this.drunk = new ChoiceController(id, "drunk");
    this.postDrunk = new ContinueController(id, "postDrunk");
    this.preDeath = new ContinueController(id, "preDeath");
    this.death = new ChoiceController(id, "death");


    this.parentsChoice = {
        LEAVE: 1,
        WATCH: 2,
        HANDJOB: 3,
        BLOWJOB: 4,
        NOPEN: 5,
        FUCK: 6
    };

    /*this.proposal = new ChangeController(id, "proposal", function () {
     }, function () {
     return global.ui.change.buildNotification([
     new Change("TODO", "CHANGE", +1)
     ]);
     });*/

    this.fragments = {};
    this.fragments.dog = new FarmerMaidDrunkDeclineDog(this);
    this.fragments.satisfied = new FarmerMaidDrunkSatisfy(this);
    this.fragments.amorousDaily = new FarmerMaidAmorousDaily(this);
    this.fragments.absentDaily = new FarmerMaidAbsentDaily(this);
    this.fragments.abusiveDaily = new FarmerMaidAbusiveDaily(this);
    this.fragments.blowjob = new FarmerMaidAbsentBlowjob(this);
    this.fragments.handjob = new FarmerMaidAbsentHandjob(this);
    this.fragments.recover = new FarmerMaidRecover(this);

    this.subControllers = {};

    //this.bgm = new AudioController(id, "res/audio/varanar/noonthreestore.mp3", 100);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}

// END scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaidController.js

// scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaid.js

/**
 * Farmer's Maid Enslavement Ending.
 */
function FarmerMaid() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "FarmerMaid";
    var sceneName = "Farmer's Maid";
    var sceneSubfolder = "Enslavement/DayTwo";
    var ctrl = new FarmerMaidController(sceneId, this);
    var arrival = new FarmerMaidArrival(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets all the required global variables such as scene id, scene name,
     * scene stack and theme.
     */
    function setGlobals() {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
    }

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += global.parser.parse(`[t]Enslavement[/t]`);
        tab += global.parser.parse(`[st]Farmer's maid[/st]`);
        tab += arrival.build();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;
    this.subfolder = sceneSubfolder;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        setGlobals();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        arrival.registerListeners();
        ctrl.autosave();
    };

    /**
     * Resets the scene to the starting point.
     */
    this.reset = function () {
        global.kobold.history.set(id, {});
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new FarmerMaid();
    global.sceneLoader.registerScene(scene.id, scene);
});

// END scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaid.js



// END SCENE FarmerMaid

